#ifndef _INC_CARTOGRAMCLASS_
#define _INC_CARTOGRAMCLASS_

class coord2D{
public:
	double x,y;
	coord2D(void){};
	~coord2D(void){};
	coord2D(double in_x, double in_y){x = in_x;y = in_y;}
	coord2D operator- (const coord2D &in)const{return coord2D(x - in.x, y - in.y);}
	coord2D operator+ (const coord2D &in)const{return coord2D(x + in.x, y + in.y);}
	coord2D operator* (const double in)const{return coord2D(in * x, in * y);}
	coord2D operator* (const coord2D &in)const{return coord2D(x * in.x, y * in.y);}
	coord2D operator/ (const double in)const{return coord2D(x / in, y / in);}
	bool operator==(const coord2D &in)const{return x == in.x && y == in.y;}
	bool operator<(const coord2D &in)const{return x < in.x;}
};

class Edge_Info{
public:
	int V[2];
	int P[2];
	Edge_Info(void){};
	~Edge_Info(void){};

	Edge_Info(const int in_V_0, const int in_V_1){
		V[0] = std::min(in_V_0, in_V_1);
		V[1] = std::max(in_V_0, in_V_1);
	}

	bool operator==(const Edge_Info &a)const{
		return V[0] == a.V[0] && V[1] == a.V[1];
	}
};

class V_Info{
public:
	bool use;
	int ID;

	V_Info(void){};
	~V_Info(void){};

	V_Info(int in_ID):use(false){
		ID = in_ID;
	}
};

typedef std::vector< int > i_vector;
typedef std::vector< double > d_vector;
typedef std::vector< coord2D > co_vector;
typedef std::vector< i_vector > i_matrix;
typedef std::vector< d_vector > d_matrix;
typedef std::vector< Edge_Info > E_vector;
typedef std::map< int, int > i_map;
typedef std::vector< V_Info > V_vector;

#endif /* _INC_TIN_CLASS_ */