#ifndef _INC_CONTINUOUSAREACARTOGRAM_CLASS_
#define _INC_CONTINUOUSAREACARTOGRAM_CLASS_

#define M_PI 3.1415926535

double sqrt_norm(const coord2D &in);
double norm(const coord2D &in);
double inner_product(const coord2D a, const coord2D b);

class Triangle_Info{
public:
	int V[3];
	int E[3];
	int P_ID;
	double Data;
	double Area;

	Triangle_Info(void){};
	~Triangle_Info(void){};

	Triangle_Info(int *in_V){
		std::copy(in_V, in_V+3, V);
		std::sort(V, V+3);
	}

	Triangle_Info(int in_V0, int in_V1, int in_V2){
		V[0] = in_V0;
		V[1] = in_V1;
		V[2] = in_V2;
		std::sort(V, V+3);
	}
};

class Polygon_Info{
public:
	int ID;
	i_vector V_ID;
	i_vector C_P;
	double Data;
	double Area;
	double Density;

	Polygon_Info(void){};
	~Polygon_Info(void){};

	Polygon_Info(int in_ID):Data(0.0){
		ID = in_ID;
	}
};

class ID_Value{
public:
	int ID;
	double Value;

	ID_Value(void){};
	~ID_Value(void){};

	ID_Value(int in_ID, double in_Value){
		ID = in_ID;
		Value = in_Value;
	}

	ID_Value& operator=(const ID_Value& a){
		ID = a.ID;
		Value = a.Value;
		return *this;
	}

	bool operator<(const ID_Value &a)const{
		return Value < a.Value;
	}

	bool operator>(const ID_Value &a)const{
		return Value > a.Value;
	}

	bool operator==(const ID_Value &a)const{
		return Value == a.Value;
	}
};
typedef std::vector< Triangle_Info > T_vector;
typedef std::vector< Polygon_Info > P_vector;

#endif /* _INC_CONTINUOUSAREACARTOGRAM_CLASS_ */