#include "stdafx.h"

bool ContinuousAreaCartogram_IO::Input_Data(char *in_Data, char *in_Area, co_vector &coord, P_vector &P, V_vector &V)
{
	i_map in_V, P_ID;

	if ((!Input_V_coord(in_Data, in_V, coord, V))||(!Input_P_V(in_Data, P_ID, P, in_V, V))
		||(!Input_Area(in_Area, P_ID, P))) return false;

	Check_PV(P, coord);
	cout<<"f[^͊"<<endl;
	return true;
}

//---Op`̒_W͂
bool ContinuousAreaCartogram_IO::Input_V_coord(char *in_Data, i_map &in_V, co_vector &coord, V_vector &V)
{
	int in_V_ID, V_ID = 0;
	coord2D in_coord;
	char input[100], tmp_char[80];
	FILE *infp;

	sprintf(input, "%sdata_vertices.txt", in_Data);
	if ((infp=fopen(input, "r")) == NULL){
		cout<<"-----_Wt@CJ܂-----"<<endl;
		return false;
	}

	fgets(tmp_char, 80, infp);
	while(!feof(infp) && !ferror(infp)){
		fscanf(infp,"%d\t%lf\t%lf\n", &in_V_ID, &in_coord.x, &in_coord.y);
		coord.push_back(in_coord);
		in_V.insert(pair<int, int>(in_V_ID, V_ID));
		V.push_back(V_Info(in_V_ID));
		++ V_ID;
	}

	fclose(infp);
	return true;
}

//---|S_f[^̓
bool ContinuousAreaCartogram_IO::Input_P_V(char *in_Data, i_map &in_P, P_vector &P, i_map &in_V, V_vector &V)
{
	int tmp_P_ID, Order, V_ID, P_ID = 0;
	char input[100], tmp_char[80];
	i_map::iterator p;
	FILE *infp;

	sprintf(input, "%sdata_polygon.txt", in_Data);
	if ((infp = fopen(input, "r")) == NULL){
		cout<<"-----Polygon_t@CJ܂-----"<<endl;
		return false;
	}

	fgets(tmp_char, 80, infp);
	while(!feof(infp) && !ferror(infp)){
		fscanf(infp,"%d\t%d\t%d\n", &tmp_P_ID, &Order, &V_ID);
		if (Order == 0){
            in_P.insert(pair<int, int>(tmp_P_ID, P_ID));

			p = in_P.find(tmp_P_ID);
			if (p == in_P.end()){
				cout<<"Polygon IDɃG[ Polygon->"<< tmp_P_ID << endl;
				return false;
			}

			P.push_back(Polygon_Info(tmp_P_ID));
			++ P_ID;
		}

		p = in_V.find(V_ID);
		if (p == in_V.end()){
			cout<<"_IDɃG[ Polygon->"<< tmp_P_ID << " Order->" << Order
				<< " Vertice->" << V_ID << endl;
			return false;
		}

		P.back().V_ID.push_back(p->second);
		V[p->second].use = true;
	}

	fclose(infp);
	return true;
}

//\f[^͂
bool ContinuousAreaCartogram_IO::Input_Area(char *in_P_Area, i_map &P_ID, P_vector &P)
{
	int in_ID;
	double in_Area;
	char tmp_char[80], in_file[100];
	FILE *infp;
	i_map::iterator p;

	sprintf(in_file, "%sdata_data.txt", in_P_Area);
	if ((infp = fopen(in_file,"r")) == NULL){
		cout<<"-----Polygon\f[^(ʐ)t@CJ܂-----"<<endl;
		return false;
	}

	fgets(tmp_char, 80, infp);
	while(!feof(infp) && !ferror(infp)){
		fscanf(infp,"%d\t%lf\n", &in_ID, &in_Area);

		p = P_ID.find(in_ID);
		if (p == P_ID.end()) /*cout<<"Wf[^ Polygon "<<in_ID<<endl*/;
		else P[p->second].Data = in_Area;
	}
	fclose(infp);

	//ʐς̓͂ĂȂPolygonꍇCI
	for (P_vector::iterator itr_P = P.begin(); itr_P < P.end(); itr_P ++){
		if ((*itr_P).Data == 0.0){
			cout<<"ʐσf[^ Polygon "<< (*itr_P).ID <<endl;			
			return false;
		}
	}
	return true;
}

//|S̒_IDvɋL^Ă邩mFCvȂ玞vɏC
void ContinuousAreaCartogram_IO::Check_PV(P_vector &P, co_vector &coord)
{
	i_vector P_V;

	for (P_vector::iterator itr_P = P.begin(); itr_P < P.end(); itr_P ++){
		P_V.resize((*itr_P).V_ID.size());
		copy((*itr_P).V_ID.begin(), (*itr_P).V_ID.end(), P_V.begin());

		if (!Check_Clockwise(P_V, coord)) copy(P_V.rbegin(), P_V.rend(), (*itr_P).V_ID.begin());
		P_V.clear();
	}
}

//|S̒_IDvɋL^Ă邩mFCvȂ玞vɏC
bool ContinuousAreaCartogram_IO::Check_Clockwise(i_vector &P_V, co_vector &coord)
{
	int i, N_V = int(P_V.size());
	double theta = 0.0, tmp_theta;
	d_vector e_d(N_V), s_v(N_V), c_v(N_V);
	co_vector Edge_Vec(N_V);
	ContinuousAreaCartogramUtility Util;

	for (i=0; i<N_V; i++) Util.calc_edge_length(i, P_V, N_V, coord, Edge_Vec, e_d);
	for (i=0; i<N_V; i++) Util.calc_angle(i, N_V, Edge_Vec, e_d, c_v, s_v);
	for (i=0; i<N_V; i++){
		if (c_v[i] == 0.0){
			if (s_v[i] > 0.0) theta += M_PI/2;
			else theta += 1.5 * M_PI;
		}
		else{
			tmp_theta = atan2(s_v[i], c_v[i]);
			if (tmp_theta < 0.0) tmp_theta += 2 * M_PI;
			theta += tmp_theta;
		}
	}

	//vȂtrue
	if (int(theta/M_PI + 2 - N_V + 0.5) == 0) return true;
	else return false;
}


void ContinuousAreaCartogram_IO::Output_P_V(char *in_Area, co_vector &coord, P_vector &P, V_vector &V)
{
	int i;
	char out_file[100];
	FILE *outfp;
	i_vector::iterator itr_i;

	sprintf(out_file, "%sdata_polygon_vertex.txt", in_Area);

	outfp=fopen(out_file, "w");
	fprintf(outfp, "gsgroup,gsorder,Vertex_ID,X,Y\n");

	for (P_vector::iterator itr_P = P.begin(); itr_P < P.end(); itr_P ++){
		for (itr_i = (*itr_P).V_ID.begin(); itr_i < (*itr_P).V_ID.end(); itr_i ++){
			fprintf(outfp, "%d,%d,%d,%.8f,%.8f\n",
				(*itr_P).ID, itr_i - (*itr_P).V_ID.begin(), V[*itr_i].ID, coord[*itr_i].x, coord[*itr_i].y);
		}

		itr_i = (*itr_P).V_ID.begin();
		fprintf(outfp, "%d,%d,%d,%.8f,%.8f\n",
			(*itr_P).ID, (*itr_P).V_ID.size(), V[*itr_i].ID, coord[*itr_i].x, coord[*itr_i].y);
	}
	fclose(outfp);

	//Wt@C
	sprintf(out_file, "%sdata_vertices_deformed.txt", in_Area);
	outfp = fopen(out_file, "w");
	fprintf(outfp,"Vertex_ID\tX\tY\n");

	for (i = 0; i < int(V.size()); i ++)
		if (V[i].use) fprintf(outfp,"%d\t%.10f\t%.10f\n", V[i].ID, coord[i].x, coord[i].y);

	fclose(outfp);
}

void ContinuousAreaCartogram_IO::Output_TIN(char *in_Area, co_vector &coord, T_vector &T)
{
	int i, Tri_ID;
	char out_filename[100];
	FILE *outfp, *outfp2;
	T_vector::iterator itr_T;
	ContinuousAreaCartogramUtility Util;

	//ArcView TIN\pt@C
	sprintf(out_filename, "%s_Triangle_Vertices.csv", in_Area);
	outfp = fopen(out_filename,"w");
	fprintf(outfp,"X,Y,gsgroup,gsorder,Vertex,Polygon_ID\n");

	//OpԖʐσf[^t@C
	sprintf(out_filename, "%s_Triangle_Area.csv", in_Area);
	outfp2 = fopen(out_filename,"w");
	fprintf(outfp2,"Triangle_ID,Data,Area,Vertex1,Vertex2,Vertex3,Polygon\n");

	for (itr_T = T.begin(); itr_T < T.end(); itr_T ++){
		Tri_ID = int(itr_T - T.begin());
		for (i = 0; i < 3;  i ++)
			fprintf(outfp,"%.5f,%.5f,%d,%d,%d,%d\n", coord[(*itr_T).V[i]].x, coord[(*itr_T).V[i]].y, Tri_ID +1, i+1, (*itr_T).V[i], (*itr_T).P_ID);

		fprintf(outfp,"%.5f,%.5f,%d,%d,%d,%d\n", coord[(*itr_T).V[0]].x, coord[(*itr_T).V[0]].y, Tri_ID +1, 3, (*itr_T).V[0], (*itr_T).P_ID);
		fprintf(outfp2,"%d,%.5f,%.5f,%d,%d,%d,%d\n", 
			Tri_ID, fabs((*itr_T).Data), fabs(Util.calc_tri_area_w_sign(coord, T[Tri_ID])), (*itr_T).V[0], (*itr_T).V[1], (*itr_T).V[2], (*itr_T).P_ID);
	}

	fclose(outfp);
	fclose(outfp2);
}