// GradientDialog.cpp : Cve[V t@C
//

#include "stdafx.h"
#include <math.h>
//#include "MapPrinter.h"
#include "GradientDialog.h"
#include "WhiteWindow.h"
//#include "resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning( disable : 4244)
/////////////////////////////////////////////////////////////////////////////
// CGradientDialog _CAO


CGradientDialog::CGradientDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CGradientDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGradientDialog)
	m_AddPos = 0.5f;
	m_DeletePos = 0.5f;
	m_NumberOfQuant = 8;
	m_EnableQuant = FALSE;
	m_EnableSample = FALSE;
	//}}AFX_DATA_INIT
	m_bShowToolTips = TRUE;
	m_UseBackground = TRUE;
	m_pView = NULL;
	m_pWin = NULL;
	m_AddColor = RGB(0,0,0);
	m_DeleteColor = RGB(255,255,255);
	m_BGColor = RGB(0,0,0);
	m_minData = 0;
	m_maxData = 100;
	m_middleData = 50;
}
CGradientDialog::CGradientDialog(CView* pView /*=NULL*/)
{
	m_AddPos = 0.5f;
	m_DeletePos = 0.5f;
	m_NumberOfQuant = 8;
	m_EnableQuant = FALSE;
	m_EnableSample = FALSE;
	m_bShowToolTips = TRUE;
	m_UseBackground = TRUE;
	m_pView = pView;
	m_pWin = NULL;
	m_AddColor = RGB(0,0,0);
	m_DeleteColor = RGB(255,255,255);
	m_BGColor = RGB(0,0,0);
	m_minData = 0;
	m_maxData = 100;
	m_middleData = 50;
}
	
BOOL CGradientDialog::ModelessCreate() 
{
	return CDialog::Create(CGradientDialog::IDD);
}

void CGradientDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGradientDialog)
	DDX_Control(pDX, IDC_COMBO_MODE, m_Mode);
	DDX_Text(pDX, IDC_EDIT_ADD, m_AddPos);
	DDV_MinMaxFloat(pDX, m_AddPos, 0.f, 1.f);
	DDX_Text(pDX, IDC_EDIT_DELETE, m_DeletePos);
	DDV_MinMaxFloat(pDX, m_DeletePos, 0.f, 1.f);
	DDX_Text(pDX, IDC_EDIT_QUANT, m_NumberOfQuant);
	DDV_MinMaxUInt(pDX, m_NumberOfQuant, 0, 50);
	DDX_Check(pDX, IDC_CHECK_QUAN, m_EnableQuant);
	DDX_Check(pDX, IDC_CHECK_HANREI, m_EnableSample);
	DDX_Control(pDX,IDC_GRADIENT,m_wndGradientCtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGradientDialog, CDialog)
	//{{AFX_MSG_MAP(CGradientDialog)
	ON_BN_CLICKED(ID_COLOR_OK, OnModelessOK)
	ON_BN_CLICKED(ID_COLOR_CANCEL, OnModelessCancel)
	ON_BN_CLICKED(IDC_BUTTON_ADD, OnButtonAdd)
	ON_BN_CLICKED(IDC_BUTTON_ADD_COLOR, OnButtonAddColor)
	ON_BN_CLICKED(IDC_BUTTON_DELETE, OnButtonDelete)
	ON_BN_CLICKED(IDC_BUTTON_DELETE_COLOR, OnButtonDeleteColor)
	ON_BN_CLICKED(IDC_CHECK_QUAN, OnCheckQuant)
	ON_EN_CHANGE(IDC_EDIT_QUANT, OnChangeEditQuant)
	ON_EN_CHANGE(IDC_EDIT_DELETE, OnChangeEditDelete)
	ON_CBN_SELCHANGE(IDC_COMBO_MODE, OnSelchangeComboMode)
	ON_BN_CLICKED(IDC_CHECK_HANREI, OnCheckHanrei)
	ON_BN_CLICKED(IDC_BUTTON_MODE1, OnButtonMode1)
	ON_BN_CLICKED(IDC_BUTTON_MODE2, OnButtonMode2)
	ON_BN_CLICKED(IDC_BUTTON_MODE3, OnButtonMode3)
	//}}AFX_MSG_MAP
	ON_NOTIFY(GC_SELCHANGE,IDC_GRADIENT,OnNotifyChangeSelPeg)
	ON_NOTIFY(GC_PEGMOVE,IDC_GRADIENT,OnNotifyPegMove)
	ON_NOTIFY(GC_PEGMOVED,IDC_GRADIENT,OnNotifyPegMove)
	ON_NOTIFY(GC_PEGREMOVED,IDC_GRADIENT,OnNotifyPegRemoved)
	ON_NOTIFY(GC_CREATEPEG,IDC_GRADIENT,OnNotifyDoubleClickCreatePeg)
	ON_NOTIFY(GC_EDITPEG,IDC_GRADIENT,OnNotifyEditPeg)
END_MESSAGE_MAP()

bool CGradientDialog::SetDataRange(double min,double max){
	m_minData = min;m_maxData = max;
	max*min >= 0 ? m_middleData = (min + max)/2 : m_middleData = 0;
	return TRUE;
}
COLORREF CGradientDialog::GetRandomColor(){
	return RGB(rand() % 256,rand() % 256,rand() % 256);
}
COLORREF CGradientDialog::GetRandomColorLight(){
	return RGB(256 - (rand() % 256 / 4),265 - (rand() % 256 / 4),256 - (rand() % 256 / 4));
}
COLORREF CGradientDialog::TranslateToColor(double Data){
	if(Data == NULL) return RGB(255,255,255);	//NULL͔̎Ԃ
	if((Data > m_maxData) || (Data < m_minData)){
		//zO
		//ASSERT(0);
		return RGB(255,255,255);
	}
	float Percent = (float)(Data - m_minData)/(float)(m_maxData - m_minData);
	return 	m_wndGradientCtrl.GetGradient().ColourFromPosition(Percent);
}
COLORREF CGradientDialog::TranslateToColor(float Data){
	if((Data > 1.0f ) || (Data < 0.0f )){	//萔𕂓_Ă
		ASSERT(0);						//zO
		return RGB(0,0,0);
	}
	return 	m_wndGradientCtrl.GetGradient().ColourFromPosition(Data);
}

/////////////////////////////////////////////////////////////////////////////
// CGradientDialog bZ[W nh

void CGradientDialog::OnButtonAdd() 
{
	UpdateData(TRUE);

	m_wndGradientCtrl.GetGradient().AddPeg(m_AddColor,m_AddPos);
	m_wndGradientCtrl.Invalidate();
	if(m_pView != NULL){
		m_pView->PostMessage(WM_COLOR_CHANGE,NULL);
	}
	if(m_pWin != NULL){
		m_pWin->PostMessage(WM_COLOR_CHANGE,NULL);
	}
}

void CGradientDialog::OnButtonAddColor() 
{
	CColorDialog dlg;
	dlg.DoModal();
	m_AddColor = dlg.GetColor();
	ButtonAddColor.SetBackGroundColor(m_AddColor);
	Invalidate();
}

void CGradientDialog::OnButtonDelete() 
{
	int res = m_wndGradientCtrl.GetSelIndex();
	switch(res){
	case STARTPEG:
		break;
	case ENDPEG:
		break;
	default:
		m_wndGradientCtrl.DeleteSelected(TRUE);
	}
	m_wndGradientCtrl.Invalidate();
	if(m_pView != NULL){
		m_pView->PostMessage(WM_COLOR_CHANGE,NULL);
	}
	if(m_pWin != NULL){
		m_pWin->PostMessage(WM_COLOR_CHANGE,NULL);
	}
}

void CGradientDialog::OnButtonDeleteColor() 
{
	CColorDialog dlg;
	dlg.DoModal();
	m_DeleteColor = dlg.GetColor();	
	ButtonDeleteColor.SetBackGroundColor(m_DeleteColor);
	//[ȊO̐F̕ύX
	int res = m_wndGradientCtrl.GetSelIndex();
	switch(res){
	case STARTPEG:
		m_wndGradientCtrl.GetGradient().SetStartPegColour(m_DeleteColor);
		break;
	case ENDPEG:
		m_wndGradientCtrl.GetGradient().SetEndPegColour(m_DeleteColor);
		break;
	default:
		m_wndGradientCtrl.SetColourSelected(m_DeleteColor,TRUE);
	}
	Invalidate();
}

BOOL CGradientDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	GetDlgItem(IDC_BUTTON_DELETE_COLOR)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_DELETE)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_DELETE)->EnableWindow(FALSE);
	
	ButtonAddColor.AutoLoad(IDC_BUTTON_ADD_COLOR,this);
	ButtonDeleteColor.AutoLoad(IDC_BUTTON_DELETE_COLOR,this);
	ButtonAddColor.SetBackGroundColor(m_AddColor);
	ButtonDeleteColor.SetBackGroundColor(m_DeleteColor);

	//----- Setup the Gradient -----//
	CGradient &rGradient = m_wndGradientCtrl.GetGradient();
	rGradient.SetEndPegColour(m_AddColor);
	rGradient.SetStartPegColour(m_DeleteColor);
	rGradient.SetUseBackground(false);

	rGradient.SetBackgroundColour(m_BGColor);
	SetControls();

	CString str("");
	str.Format(_T(" %f"),m_maxData);
	GetDlgItem(IDC_STATIC_MAX)->SetWindowText(str);
	str.Format(_T(" %f"),m_minData);
	GetDlgItem(IDC_STATIC_MIN)->SetWindowText(str);

	OnCheckHanrei();

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CGradientDialog::OnNotifyDoubleClickCreatePeg(NMHDR * pNotifyStruct, LRESULT *result)
{
	PegCreateNMHDR* pPegCreateNotifyStruct = (PegCreateNMHDR*)pNotifyStruct;
	
	UpdateData(TRUE);
	m_wndGradientCtrl.GetGradient().AddPeg(pPegCreateNotifyStruct->colour,pPegCreateNotifyStruct->position);
	m_wndGradientCtrl.Invalidate();

	if(m_pView != NULL){
		m_pView->PostMessage(WM_COLOR_CHANGE,NULL);
	}
	if(m_pWin != NULL){
		m_pWin->PostMessage(WM_COLOR_CHANGE,NULL);
	}
}

void CGradientDialog::OnNotifyEditPeg(NMHDR * pNotifyStruct, LRESULT *result)
{
	PegNMHDR* pPegNotifyStruct = (PegNMHDR*)pNotifyStruct;
	
	CString message;
	message.Format(_T("Position: %.2f\nColour: RGB(%u, %u, %u)"), pPegNotifyStruct->peg.position,
		GetRValue(pPegNotifyStruct->peg.colour),
		GetGValue(pPegNotifyStruct->peg.colour),
		GetBValue(pPegNotifyStruct->peg.colour));
	MessageBox(message, _T("You just double clicked on a peg!"));
}

void CGradientDialog::OnNotifyChangeSelPeg(NMHDR * pNotifyStruct, LRESULT *result)
{
	PegNMHDR* pPegNotifyStruct = (PegNMHDR*)pNotifyStruct;
	CString str;
	if(pPegNotifyStruct->index == -1){
		GetDlgItem(IDC_BUTTON_DELETE_COLOR)->EnableWindow(FALSE);

		GetDlgItem(IDC_EDIT_DELETE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_DELETE)->EnableWindow(FALSE);
		GetDlgItem(IDC_STATIC_POS_DELETE)->SetWindowText(_T("I"));
	}else{	
		GetDlgItem(IDC_BUTTON_DELETE_COLOR)->EnableWindow(TRUE);
		//GetDlgItem(IDC_BUTTON_DELETE)->EnableWindow(TRUE);

		m_DeleteColor = pPegNotifyStruct->peg.colour;
		m_DeletePos = max(0, pPegNotifyStruct->peg.position);
		UpdateData(FALSE);
		ButtonDeleteColor.SetBackGroundColor(m_DeleteColor);
		Invalidate();

		GetDlgItem(IDC_EDIT_DELETE)->EnableWindow(
				pPegNotifyStruct->index >= 0
			);
		GetDlgItem(IDC_BUTTON_DELETE)->EnableWindow(
				pPegNotifyStruct->index >= 0
			);

		CString append;
		
		switch(pPegNotifyStruct->index){
			case STARTPEG: append = _T("["); break;
			case ENDPEG: append = _T("["); break;
			default: append = _T(""); break;
		}
		str.Format(_T("ID %d%s"), pPegNotifyStruct->index, append);
		GetDlgItem(IDC_STATIC_DELETE)->SetWindowText(str);
	}
}

void CGradientDialog::OnNotifyPegMove(NMHDR * pNotifyStruct, LRESULT *result)
{
	PegNMHDR* pPegNotifyStruct = (PegNMHDR*)pNotifyStruct;
	
	m_DeletePos = pPegNotifyStruct->peg.position;
	UpdateData(FALSE);
	if(m_pView != NULL){
		m_pView->PostMessage(WM_COLOR_CHANGE,NULL);
	}
	if(m_pWin != NULL){
		m_pWin->PostMessage(WM_COLOR_CHANGE,NULL);
	}
}

void CGradientDialog::OnNotifyPegMoved(NMHDR* , LRESULT *result)
{
	if(m_pView != NULL){
		m_pView->PostMessage(WM_COLOR_CHANGE,NULL);
	}
	if(m_pWin != NULL){
		m_pWin->PostMessage(WM_COLOR_CHANGE,NULL);
	}
}

void CGradientDialog::OnNotifyPegRemoved(NMHDR* , LRESULT *result)
{
	if(m_pView != NULL){
		m_pView->PostMessage(WM_COLOR_CHANGE,NULL);
	}
	if(m_pWin != NULL){
		m_pWin->PostMessage(WM_COLOR_CHANGE,NULL);
	}
}

void CGradientDialog::OnHorizontal() 
{
	GetDlgItem(IDC_GRADIENT)->SetWindowPos(GetDlgItem(IDC_GRADIENT), 10,225, 830, 120, SWP_NOZORDER);
}

void CGradientDialog::OnVertical() 
{
	GetDlgItem(IDC_GRADIENT)->SetWindowPos(GetDlgItem(IDC_GRADIENT), 11,11, 107, 330, SWP_NOZORDER);
}

void CGradientDialog::OnRightTop() 
{
	//m_wndGradientCtrl.SetPegSide(true, ((CButton*)GetDlgItem(IDC_RIGHT_TOP))->GetCheck());
	m_wndGradientCtrl.Invalidate();
}

void CGradientDialog::OnLeftBottom() 
{
	//m_wndGradientCtrl.SetPegSide(false, ((CButton*)GetDlgItem(IDC_LEFT_BOTTOM))->GetCheck());
	m_wndGradientCtrl.Invalidate();
}
void CGradientDialog::OnShowtooltips() 
{
	UpdateData();
	m_wndGradientCtrl.ShowTooltips(m_bShowToolTips);
}

void CGradientDialog::SetControls()
{
	//----- Set the interpolation method -----//
	m_Mode.SetCurSel((int)m_wndGradientCtrl.GetGradient().GetInterpolationMethod());
	GetDlgItem(IDC_EDIT_QUANT)->EnableWindow(FALSE);
	
	//----- Set the dialog's selection -----//
	LRESULT result;
	PegNMHDR nmhdr;
	nmhdr.nmhdr.code = 0;
	nmhdr.nmhdr.idFrom = 0;
	nmhdr.nmhdr.hwndFrom = 0;
	nmhdr.index = -1;
	OnNotifyChangeSelPeg((NMHDR*) &nmhdr, &result);

	//----- Select the right radio button -----//
	m_wndGradientCtrl.SetPegSide(true, true);	//EijL
	m_wndGradientCtrl.SetPegSide(false, false);	//!(E)
}

void CGradientDialog::OnCheckQuant() 
{
	UpdateData();
	GetDlgItem(IDC_EDIT_QUANT)->EnableWindow(m_EnableQuant);
	m_wndGradientCtrl.GetGradient().SetQuantization(m_EnableQuant ? m_NumberOfQuant : -1);
	m_wndGradientCtrl.Invalidate();	
	if(m_pView != NULL){
		m_pView->PostMessage(WM_COLOR_CHANGE,NULL);
	}
	if(m_pWin != NULL){
		m_pWin->PostMessage(WM_COLOR_CHANGE,NULL);
	}
}


void CGradientDialog::OnChangeEditQuant() 
{
	UpdateData();
	m_wndGradientCtrl.GetGradient().SetQuantization(m_EnableQuant ? m_NumberOfQuant : -1);
	m_wndGradientCtrl.Invalidate();	
	if(m_pView != NULL){
		m_pView->PostMessage(WM_COLOR_CHANGE,NULL);
	}
	if(m_pWin != NULL){
		m_pWin->PostMessage(WM_COLOR_CHANGE,NULL);
	}
}

void CGradientDialog::OnChangeEditDelete() 
{
	UpdateData(TRUE);
	int newsel = m_wndGradientCtrl.MoveSelected(m_DeletePos, TRUE); 
		
	CString append,str;
		
	switch(newsel){
		case STARTPEG: append = _T("["); break;
		case ENDPEG: append = _T("["); break;
		default: append = _T(""); break;
	}
	str.Format(_T("ID %d%s"), newsel, append);
	GetDlgItem(IDC_STATIC_DELETE)->SetWindowText(str);
	
	if(m_pView != NULL){
		m_pView->PostMessage(WM_COLOR_CHANGE,NULL);
	}	
	if(m_pWin != NULL){
		m_pWin->PostMessage(WM_COLOR_CHANGE,NULL);
	}
}

void CGradientDialog::OnSelchangeComboMode() 
{
	int sel = m_Mode.GetCurSel();
	if(sel == -1) return;
	m_wndGradientCtrl.GetGradient().SetInterpolationMethod((CGradient::InterpolationMethod)sel);

	m_wndGradientCtrl.Invalidate();
	if(m_pView != NULL){
		m_pView->PostMessage(WM_COLOR_CHANGE,NULL);
	}	
	if(m_pWin != NULL){
		m_pWin->PostMessage(WM_COLOR_CHANGE,NULL);
	}
}

void CGradientDialog::OnCheckHanrei() 
{
	UpdateData();
	int res;
	if(m_EnableSample && (m_pWin == NULL)){
		m_pWin = new CWhiteWindow;
	/*	res = m_pWin->Create(NULL,		//windowclass
				"sample",			//window name
				WS_OVERLAPPEDWINDOW | WS_VISIBLE,	//window style
				CRect(10, 10, 210, 210),	//position
				this,					//parent window
				IDC_SAMPLE_WINDOW);		//id of this window*/
		res = m_pWin->CreateEx(CRect(10, 10, 210, 510),	//position
				this);		//id of this window*/
		m_pWin->AttachDialog(this);
	}
	if(!m_EnableSample && (m_pWin != NULL)){
		m_pWin->DestroyWindow();
		delete m_pWin;
		m_pWin = NULL;
	}
}

void CGradientDialog::OnButtonMode1() 
{
	for(int i = m_wndGradientCtrl.GetGradient().GetPegCount() - 1;i >= 0;i--){
		m_wndGradientCtrl.GetGradient().RemovePeg(i);
	}
	m_wndGradientCtrl.GetGradient().SetEndPegColour(RGB(0,0,255));
	m_wndGradientCtrl.GetGradient().SetStartPegColour(RGB(255,255,255));
	m_wndGradientCtrl.GetGradient().SetInterpolationMethod(CGradient::InterpolationMethod::Linear);
	CComboBox* pCombo = (CComboBox*)GetDlgItem(IDC_COMBO_MODE);
	pCombo->SetCurSel(CGradient::InterpolationMethod::Linear);
	Invalidate();
	if(m_pView != NULL){
		m_pView->PostMessage(WM_COLOR_CHANGE,NULL);
	}	
	if(m_pWin != NULL){
		m_pWin->PostMessage(WM_COLOR_CHANGE,NULL);
	}
}

void CGradientDialog::OnButtonMode2() 
{
	for(int i = m_wndGradientCtrl.GetGradient().GetPegCount() - 1;i >= 0;i--){
		m_wndGradientCtrl.GetGradient().RemovePeg(i);
	}
	m_wndGradientCtrl.GetGradient().SetEndPegColour(RGB(0,0,255));
	m_wndGradientCtrl.GetGradient().AddPeg(RGB(0,0,255), 1);
	m_wndGradientCtrl.GetGradient().SetStartPegColour(RGB(255,0,0));
	m_wndGradientCtrl.GetGradient().AddPeg(RGB(255,0,0), 0);
	float Percent = (float)(m_middleData - m_minData)/(m_maxData - m_minData);
	m_wndGradientCtrl.GetGradient().AddPeg(RGB(255,255,255), Percent);
	m_wndGradientCtrl.GetGradient().SetInterpolationMethod(CGradient::InterpolationMethod::Linear);
	CComboBox* pCombo = (CComboBox*)GetDlgItem(IDC_COMBO_MODE);
	pCombo->SetCurSel(CGradient::InterpolationMethod::Linear);
	Invalidate();
	if(m_pView != NULL){
		m_pView->PostMessage(WM_COLOR_CHANGE,NULL);
	}	
	if(m_pWin != NULL){
		m_pWin->PostMessage(WM_COLOR_CHANGE,NULL);
	}
}

void CGradientDialog::OnButtonMode3() 
{
	for(int i = m_wndGradientCtrl.GetGradient().GetPegCount() - 1;i >= 0;i--){
		m_wndGradientCtrl.GetGradient().RemovePeg(i);
	}
	m_wndGradientCtrl.GetGradient().SetEndPegColour(RGB(255,0,0));
	m_wndGradientCtrl.GetGradient().SetStartPegColour(RGB(0,0,255));
	m_wndGradientCtrl.GetGradient().SetInterpolationMethod(CGradient::InterpolationMethod::HSLBlueRed);
	CComboBox* pCombo = (CComboBox*)GetDlgItem(IDC_COMBO_MODE);
	pCombo->SetCurSel(CGradient::InterpolationMethod::HSLBlueRed);
	Invalidate();
	if(m_pView != NULL){
		m_pView->PostMessage(WM_COLOR_CHANGE,NULL);
	}	
	if(m_pWin != NULL){
		m_pWin->PostMessage(WM_COLOR_CHANGE,NULL);
	}
}

void CGradientDialog::OnModelessOK() 
{
	UpdateData();
	if(m_pView != NULL){
		m_pView->PostMessage(WM_COLOR_CLOSED,NULL);
	}
	if(m_EnableSample){
		m_pWin->DestroyWindow();
		delete m_pWin;
		m_pWin = NULL;
	}
}

void CGradientDialog::OnModelessCancel() 
{
	if(m_pView != NULL){
		m_pView->PostMessage(WM_COLOR_CLOSED,NULL);
	}
	if(m_EnableSample){
		m_pWin->DestroyWindow();
		delete m_pWin;
		m_pWin = NULL;
	}
}

bool CGradientDialog::DrawChart(CDC *pDC, CRect *pRect,LPCTSTR pTitle,int FontTitle,int FontMesure,int a)
{
	if(pRect->Width() < 10) return false;
	CString str;
	CSize sizeText;
	CPen* pPen,* pOldPen;
	//CBrush* pBrush;
	CBrush* pOldBrush;
	CPen penPen(PS_SOLID, 1, RGB(0,0,0));
	CFont Font,TitleFont;
	Font.CreateFont(
		FontMesure,						// nHeight
		0,								// nWidth
		0,								// nEscapement
		0,								// nOrientation
		FW_NORMAL,						// nWeight
		FALSE,							// bItalic
		FALSE,							// bUnderline
		0,								// cStrikeOut
		DEFAULT_CHARSET,				// nCharSet
		OUT_DEFAULT_PRECIS,				// nOutPrecision
		CLIP_DEFAULT_PRECIS,			// nClipPrecision
		DEFAULT_QUALITY,				// nQuality
		DEFAULT_PITCH | FF_DONTCARE,	// nPitchAndFamily
		"lr");					// lpszFacename
	CFont* def_Font = pDC->SelectObject(&Font);
	pOldPen = (CPen*)pDC->SelectStockObject(BLACK_PEN);
	pOldBrush = (CBrush*)pDC->SelectStockObject(BLACK_BRUSH);
	pDC->SetPolyFillMode(WINDING);
	//c
	sizeText = pDC->GetOutputTextExtent(str);
	pRect->top = pRect->top - sizeText.cy * 2;
	bool bVertical = FALSE;
	bool bEnds = TRUE;
	int h = -1 * pRect->Height();
	int w = pRect->Width();
	int x = pRect->left;
	int y = pRect->top;
	if(h > w) bVertical = TRUE;
	//iK
	int i;
	int arm = a;
	double c,ct;
	int Quant = 10;
	//if(!m_EnableQuant)
	//Xebv
	double range = m_maxData - m_minData;		//f[^͈
	double log = log10(range);
	//double mod;								//
	//log = modf(log,&mod);						//
	log = ceil(log) - 1;
	double step = pow(10,log);					//Xebv
	if(bVertical){
		//c
		for(i = 0;i < h;i++){
			pPen = new CPen(PS_SOLID,1, TranslateToColor((float)i / (float)h));
			pOldPen = pDC->SelectObject(pPen);
			pDC->MoveTo(x,y - h + i);
			pDC->LineTo(x + w,y - h + i);
			pDC->SelectObject(pOldPen);
			delete pPen;
		}
		//[\
		if(bEnds){
			str.Format("%4f",m_minData);
			pDC->MoveTo(x + w,y - h);
			pDC->LineTo(x + w + arm * 2,y - h);
			sizeText = pDC->GetOutputTextExtent(str);
			pDC->TextOut(x + w + arm * 2.2,y - h + sizeText.cy/2,str);
			str.Format("%4f",m_maxData);
			pDC->MoveTo(x + w,y);
			pDC->LineTo(x + w + arm * 2,y);
			sizeText = pDC->GetOutputTextExtent(str);
			pDC->TextOut(x + w + arm * 2.2 ,y + sizeText.cy/2,str);
		}
		//ڐ\
		if(m_middleData != 0){		//[񂾃f[^̏ꍇ
			for(i = -1 * Quant;i < Quant;i++){
				c = m_middleData + i * step;
				if((c > m_minData) && (c < m_maxData)){
					str.Format("%4f",c);
					ct = (c - m_minData)/ range;
					pDC->MoveTo(x + w,y - h + ct*h);
					pDC->LineTo(x + w + arm,y - h + ct*h);
					sizeText = pDC->GetOutputTextExtent(str);
					pDC->TextOut(x + w + arm * 1.2,y - h + ct*h + sizeText.cy/2,str);
				}
			}
		}
		else{						//ʏf[^̏ꍇ
			c = ceil(m_minData / step - 1) * step;
			for(i = 0;i < Quant;i++){
				c = c + step;
				if((c > m_minData) && (c < m_maxData)){
					str.Format("%4f",c);
					ct = (c - m_minData)/ range;
					pDC->MoveTo(x + w,y - h + ct*h);
					pDC->LineTo(x + w + arm,y - h + ct*h);
					sizeText = pDC->GetOutputTextExtent(str);
					pDC->TextOut(x + w + arm * 1.5,y - h + ct*h + sizeText.cy/2,str);
				}
			}
		}
	}else{
		//
		for(i = 0;i < w;i++){
			pPen = new CPen(PS_SOLID,1, TranslateToColor((float)i / (float)w));
			pOldPen = pDC->SelectObject(pPen);
			pDC->MoveTo(x + i,y);
			pDC->LineTo(x + i,y - h);
			pDC->SelectObject(pOldPen);
			delete pPen;
		}
		//[\
		if(bEnds){
			str.Format("%4f",m_minData);
			pDC->MoveTo(x,y);
			pDC->LineTo(x,y + arm);
			sizeText = pDC->GetOutputTextExtent(str);
			pDC->TextOut(x - sizeText.cx/2,y + 110,str);
			str.Format("%4f",m_maxData);
			pDC->MoveTo(x + w,y);
			pDC->LineTo(x + w,y + arm);
			sizeText = pDC->GetOutputTextExtent(str);
			pDC->TextOut(x + w - sizeText.cx/2,y + arm * 1.5,str);
		}
		//ڐ\
		if(m_middleData != 0){		//[񂾃f[^̏ꍇ
			for(i = -1 * Quant;i < Quant;i++){
				c = m_middleData + i * step;
				if((c > m_minData) && (c < m_maxData)){
					str.Format("%5f",c);
					ct = (c - m_minData)/ range;
					pDC->MoveTo(x + ct * w,y);
					pDC->LineTo(x + ct * w,y + arm);
					sizeText = pDC->GetOutputTextExtent(str);
					pDC->TextOut(x + ct * w - sizeText.cx/2,y + arm * 1.5,str);
				}
			}
		}
		else{						//ʏf[^̏ꍇ
			c = ceil(m_minData / step - 1) * step;
			for(i = 0;i < Quant;i++){
				c = c + step;
				if((c > m_minData) && (c < m_maxData)){
					str.Format("%5f",c);
					ct = (c - m_minData)/ range;
					pDC->MoveTo(x + ct * w,y);
					pDC->LineTo(x + ct * w,y + arm);
					sizeText = pDC->GetOutputTextExtent(str);
					pDC->TextOut(x + ct * w - sizeText.cx/2,y + arm * 1.5,str);
				}
			}
		}
	}
	pDC->SelectObject(def_Font);
	//ڐ\

	//^Cg\
	TitleFont.CreateFont(
		FontTitle,						// nHeight
		0,								// nWidth
		0,								// nEscapement
		0,								// nOrientation
		FW_NORMAL,						// nWeight
		FALSE,							// bItalic
		FALSE,							// bUnderline
		0,								// cStrikeOut
		DEFAULT_CHARSET,				// nCharSet
		OUT_DEFAULT_PRECIS,				// nOutPrecision
		CLIP_DEFAULT_PRECIS,			// nClipPrecision
		DEFAULT_QUALITY,				// nQuality
		DEFAULT_PITCH | FF_DONTCARE,	// nPitchAndFamily
		"lr");					// lpszFacename
	def_Font = pDC->SelectObject(&TitleFont);
	sizeText = pDC->GetOutputTextExtent(pTitle);
	pDC->TextOut(x + w/2 - sizeText.cx/2 ,y + sizeText.cy * 2,pTitle);


	// Put back the old objects.
	pDC->SelectObject(pOldBrush);
	pDC->SelectObject(pOldPen);
	pDC->SelectObject(def_Font);
	Font.DeleteObject();
	TitleFont.DeleteObject();
	return TRUE;
}
