// PlotterView.cpp : CPlotterView NX̎
//

#include "stdafx.h"
#include "Plotter.h"
#include "MainFrm.h"
#include "PlotterDoc.h"
#include "PlotterView.h"
#include "Projection.h"
#include "GroupDelete.h"
#include "FolderDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CPlotterView

IMPLEMENT_DYNCREATE(CPlotterView, CView)

BEGIN_MESSAGE_MAP(CPlotterView, CView)
	ON_COMMAND(ID_ORG_UP, OnUpOrg)
	ON_COMMAND(ID_ORG_DOWN, OnDownOrg)
	ON_COMMAND(ID_ORG_LEFT, OnLeftOrg)
	ON_COMMAND(ID_ORG_RIGHT, OnRightOrg)
	ON_COMMAND(ID_ZOOMIN, OnZoomin)
	ON_COMMAND(ID_ZOOMOUT, OnZoomout)
	ON_COMMAND(ID_CHANGE_POLY, OnNextPoly)
	ON_WM_RBUTTONDOWN()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	// WR}h
	ON_COMMAND(ID_FILE_PAGE_SETUP, &CPlotterView::OnPageSetup)
	ON_COMMAND(ID_FILE_PRINT, &CPlotterView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CPlotterView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CPlotterView::OnFilePrintPreview)
	ON_COMMAND_RANGE(ID_POINT_MODE,ID_PRINT_MODE,&CPlotterView::OnChangeMode)
	ON_UPDATE_COMMAND_UI_RANGE(ID_POINT_MODE,ID_PRINT_MODE,&CPlotterView::OnUpdateModeMenu)
	ON_UPDATE_COMMAND_UI(ID_LAYER_SHOW,&CPlotterView::OnUpdateModeMenu)
	ON_COMMAND(ID_SHIFT_MAGNIFY, &CPlotterView::OnEditShiftMagnify)
	ON_COMMAND(ID_VERTEX_READ, &CPlotterView::OnVertexRead)
	ON_COMMAND(ID_POLYGON_READ, &CPlotterView::OnPolygonRead)
	ON_COMMAND(ID_VERTEX_WRITE_RAW, &CPlotterView::OnVertexWriteRaw)
	ON_COMMAND(ID_VERTEX_WRITE, &CPlotterView::OnVertexWrite)
	ON_COMMAND(ID_POLYGON_WRITE, &CPlotterView::OnPolygonWrite)
	ON_COMMAND(ID_VALID_CHECK, &CPlotterView::OnValidCheck)
	ON_COMMAND(ID_FIT_PAPER, &CPlotterView::OnFitPaper)
	ON_COMMAND(ID_COLOR_CHANGE, &CPlotterView::OnColorChange)
	ON_MESSAGE(WM_COLOR_CHANGE, OnNewColorRedraw)
	ON_MESSAGE(WM_COLOR_CLOSED, OnClosed)
	ON_COMMAND(ID_DATA_READ, &CPlotterView::OnDataRead)
	ON_COMMAND(ID_OPTION, &CPlotterView::OnOption)
	ON_COMMAND(ID_REFERENCE_READ, &CPlotterView::OnReferenceRead)
	ON_COMMAND(ID_NOCHECK_VERTTEX_READ, &CPlotterView::OnNocheckVerttexRead)
	ON_COMMAND(ID_NOCHECK_POLYGON_READ, &CPlotterView::OnNocheckPolygonRead)
	ON_COMMAND(ID_TRANSLATE, &CPlotterView::OnTranslate)
	ON_COMMAND(ID_LAYER_SHOW, &CPlotterView::OnLayerShow)
	ON_COMMAND(ID_LAYER_VERTEX, &CPlotterView::OnLayerVertex)
	ON_COMMAND(ID_LAYER_POLYGON, &CPlotterView::OnLayerPolygon)
	ON_COMMAND(ID_IDREMAE, &CPlotterView::OnIdRename)
	ON_COMMAND(ID_GROUPDELETE, &CPlotterView::OnGroupDelete)
	ON_COMMAND(ID_FORCEDSAVE, &CPlotterView::OnForcedsave)
	ON_COMMAND(ID_OPENCARTO, &CPlotterView::OnOpencarto)
	ON_COMMAND(ID_OPENDEFORMED, &CPlotterView::OnOpendeformed)
END_MESSAGE_MAP()

// CPlotterView RXgNV/fXgNV

CPlotterView::CPlotterView(){
	m_Mode = 2;	//{[h
	m_bName = FALSE;
	m_rectLegion = CRect(0,100,50,0);
	m_FontSize = 40;
	m_DataRangeMax = m_DataRangeMin = 0;

	m_sizeWindows.cx = 10000;m_sizeWindows.cy = -10000;	//_W̊
	m_sizeView.cx = m_sizeView.cy = 1000;				//r[̊

	m_Offset.x = m_Offset.y = 0;
	m_WindowOrg.x = m_WindowOrg.y = 500;
	m_Stroke = 1000;
	//}EXf[^
	m_Pointer = m_Position = CPoint(0,0);
	//J[_CAO
	m_bColorDialogOn = FALSE;
	m_pColor = new CGradientDialog(this);
	m_UpperLimit = 9999999;
	m_LowerLimit = 1;
	m_PointSize = 5;
	//E֌W
	m_bBoundary = FALSE;
	m_BoundaryUnit = 100000;
	m_BoundarySize = 5;
}

CPlotterView::~CPlotterView(){delete m_pColor;}
BOOL CPlotterView::PreCreateWindow(CREATESTRUCT& cs){return CView::PreCreateWindow(cs);}

// CPlotterView `
void CPlotterView::OnDraw(CDC* pDC){
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc) return;

	CMainFrame* pFrame = (CMainFrame*)AfxGetApp()->m_pMainWnd;
	CString str;
	str = TEXT("`悵Ă܂");
	pFrame->m_wndStatusBar.SetPaneText(0,str);	

	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
	//p`
	CFont Font;
	Font.CreateFont(
		m_FontSize,						// nHeight
		0,								// nWidth
		0,								// nEscapement
		0,								// nOrientation
		FW_NORMAL,						// nWeight
		FALSE,							// bItalic
		FALSE,							// bUnderline
		0,								// cStrikeOut
		DEFAULT_CHARSET,				// nCharSet
		OUT_DEFAULT_PRECIS,				// nOutPrecision
		CLIP_DEFAULT_PRECIS,			// nClipPrecision
		DEFAULT_QUALITY,				// nQuality
		DEFAULT_PITCH | FF_DONTCARE,	// nPitchAndFamily
		TEXT("lrSVbN"));	// lpszFacename
	CFont* def_Font = pDC->SelectObject(&Font);
	CSize sizeText;
	pDC->SetBkMode(TRANSPARENT);	//̔wi𓧖ɂ

	if(!pDC->IsPrinting()){
		if(m_Mode == 3){
			pDC->Rectangle(0,m_sizePrintable.cy,m_sizePrintable.cx,0);
		}
	}
	//p`I

	//Fݒ
	CBrush* pBrush,* pOldBrush;
	COLORREF l_Color;
	POSITION pos;
	CPolygon* pPoly;
	CCoord* pPos;
	//C[̕\
	if(m_bLayer){
		pBrush = new CBrush(RGB(150,255,255));
		pOldBrush = pDC->SelectObject(pBrush);
		pos = pDoc->m_LayerPolyList.GetHeadPosition();
		while(pos != NULL){
			pPoly = pDoc->m_LayerPolyList.GetNext(pos);
			pPoly->GetPointArray();
			pDC->Polygon(pPoly->m_PointArray,pPoly->count);
		}
		pDC->SelectObject(pOldBrush);
		delete pBrush;
	}

	//xNg̕\
	//m_Mode 0:W[h@1:xNg[h@2:{[h@3:[h
	pos = pDoc->m_PolyList.GetHeadPosition();
	while(pos != NULL){
		pPoly = pDoc->m_PolyList.GetNext(pos);
		pPoly->GetPointArray();
		if(m_Mode != 3){
			pBrush = new CBrush(RGB(200,200,200));
			pOldBrush = pDC->SelectObject(pBrush);
			pDC->Polygon(pPoly->m_PointArray,pPoly->count);
			pDC->SelectObject(pOldBrush);
			delete pBrush;
			//pDC->Polyline(pPoly->GetPointArray(),pPoly->count);
		}else{
			if((m_Mode == 3) && (pPoly->PolyID >= m_LowerLimit) && (pPoly->PolyID <= m_UpperLimit)){
				if(pDoc->m_PolyList.m_bData){
					l_Color = m_pColor->TranslateToColor(pPoly->data);	//NULLȂ甒
					pBrush = new CBrush(l_Color);
					pOldBrush = pDC->SelectObject(pBrush);
				}
				pDC->Polygon(pPoly->m_PointArray,pPoly->count);
				if(pDoc->m_PolyList.m_bData){
					pDC->SelectObject(pOldBrush);
					delete pBrush;
				}
			}
		}
	}
	if(m_bName){
		pos = pDoc->m_PolyList.GetHeadPosition();
		while(pos != NULL){
			pPoly = pDoc->m_PolyList.GetNext(pos);
			sizeText = pDC->GetOutputTextExtent(pPoly->name);
			pDC->TextOut(pPoly->m_Centroid.x - sizeText.cx / 2,pPoly->m_Centroid.y - sizeText.cy / 2,pPoly->name,(int)strlen(pPoly->name));
		}
	}
	//xNg̕\I
	//ʐς̐
	//JgxNg̕\
	if((pDoc->m_PolyList.pCurrentPoly != NULL) && (m_Mode == 1)){//xNg[h
		CPen pen(PS_SOLID,0.5,RGB(0,0,0));
		CPen* pPen;
		pPen = pDC->SelectObject(&pen);
		CBrush brush(RGB(100,100,100));
		CBrush* pBrush;
		pBrush = pDC->SelectObject(&brush);
			pPoly = pDoc->m_PolyList.pCurrentPoly;
			pDC->Polygon(pPoly->m_PointArray,pPoly->count);
		pDC->SelectObject(pPen);
		pDC->SelectObject(pBrush);
	}
	//JgxNg̕\I
	//C[̕\
	if(m_bLayer){
		pos = pDoc->m_LayerCoordList.GetHeadPosition();
		while(pos != NULL){
			pPos = pDoc->m_LayerCoordList.GetNext(pos);
			SetPlot(pDC,pPos,0);
		}
	}
	//W̕\
	if(m_Mode != 3){
		pos = pDoc->m_CoordList.GetHeadPosition();
		while(pos != NULL){
			pPos = pDoc->m_CoordList.GetNext(pos);
			SetPlot(pDC,pPos,pPos->count);//[hȊO
		}
	}
	//W̕\I
	//E̕W
	if(m_bBoundary){
		CPen penBoundary(PS_SOLID,m_BoundarySize,RGB(0,0,0));
		CPen* pPenBoundary;
		pPenBoundary = pDC->SelectObject(&penBoundary);
		CEdgeList m_Edge(pDoc->m_PolyList);
		CEdge* pEdge;
		CCoord* pPosBoundary;
		bool bVisible;
		pos = m_Edge.GetHeadPosition();
		while(pos != NULL){
			pEdge = m_Edge.GetNext(pos);
			bVisible = ((pEdge->nPolygon[0] >= m_LowerLimit) && (pEdge->nPolygon[0] <= m_UpperLimit)) || ((pEdge->nPolygon[1] >= m_LowerLimit) && (pEdge->nPolygon[1] <= m_UpperLimit));
			if(bVisible){
				if(pEdge->nPolygon[0] / m_BoundaryUnit != pEdge->nPolygon[1] / m_BoundaryUnit){
					pPosBoundary = pDoc->m_CoordList.GetAt(pEdge->P[0]);
					pDC->MoveTo(pPosBoundary->x,pPosBoundary->y);
					pPosBoundary = pDoc->m_CoordList.GetAt(pEdge->P[1]);
					pDC->LineTo(pPosBoundary->x,pPosBoundary->y);
				}
			}
		}
		pDC->SelectObject(pPenBoundary);
	}

	//F̖}̕\
	if(m_pColor->m_EnableSample){
		CString str = TEXT("F̎wW");
		m_pColor->DrawChart(pDC,&m_rectLegion,str,m_FontSize,m_FontSize*0.8,m_rectLegion.Width() / 3);
	}
}

void CPlotterView::SetPlot(CDC *pDC,CCoord* pPos,int style){
	int size = m_PointSize;
	int x = (int)pPos->x;
	int y = (int)pPos->y;
	CPen pen(PS_SOLID,1,RGB(0,0,0));
	CBrush br(RGB(0,0,0));
	CPen* pPen;
	CBrush* pBr;
	pPen = pDC->SelectObject(&pen);
	switch(style){
	case 0:	//~^
		pDC->MoveTo(x - size*4,y + size*4);
		pDC->LineTo(x + size*4,y - size*4);
		pDC->MoveTo(x - size*4,y - size*4);
		pDC->LineTo(x + size*4,y + size*4);
		break;
	case 1:	//^
		pDC->SelectStockObject(WHITE_BRUSH);
		pDC->Ellipse(x - size,y + size,x + size,y - size);
		break;
	case 2:	//^
		pBr = pDC->SelectObject(&br);
		pDC->Ellipse(x - size,y + size,x + size,y - size);
		pDC->SelectObject(pBr);
		break;
	case 3:	//^
		pBr = pDC->SelectObject(&br);
		pDC->Rectangle(x - size,y + size,x + size,y - size);
		pDC->SelectObject(pBr);
		break;
	case 4:	//^
		pBr = pDC->SelectObject(&br);
		pDC->Rectangle(x - size,y + size,x + size,y - size);
		pDC->SelectObject(pBr);
		break;
	default:
		pDC->SelectStockObject(WHITE_BRUSH);
		pDC->Rectangle(x - size,y + size,x + size,y - size);
		break;
	}
	pDC->SelectObject(pPen);
}

// CPlotterView ff

#ifdef _DEBUG
void CPlotterView::AssertValid() const{CView::AssertValid();}
void CPlotterView::Dump(CDumpContext& dc) const{CView::Dump(dc);}
CPlotterDoc* CPlotterView::GetDocument() const {
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPlotterDoc)));
	return (CPlotterDoc*)m_pDocument;
}
#endif //_DEBUG

void CPlotterView::OnNextPoly() {
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if(m_Mode == 1){
		CCoord POS;
		POS.x = m_Pointer.x;POS.y = m_Pointer.y;
		pDoc->m_PolyList.ChangeCurrentPolygon(POS);
		pDoc->UpdateStatus();
		Invalidate(TRUE);
	}
}

void CPlotterView::OnUpOrg() {m_WindowOrg.Offset(0,-m_Stroke);Invalidate(TRUE);}
void CPlotterView::OnDownOrg() {m_WindowOrg.Offset(0,m_Stroke);Invalidate(TRUE);}
void CPlotterView::OnLeftOrg() {m_WindowOrg.Offset(m_Stroke,0);	Invalidate(TRUE);}
void CPlotterView::OnRightOrg() {m_WindowOrg.Offset(-m_Stroke,0);Invalidate(TRUE);}
void CPlotterView::OnZoomin() {
	if(m_sizeView.cx < 20000000) m_sizeView.cx = m_sizeView.cy = m_sizeView.cy * 2;		//傫قǑ傫ʂ	
	Invalidate(TRUE);
}
void CPlotterView::OnZoomout() {
	if(m_sizeView.cx > 10) m_sizeView.cx = m_sizeView.cy = m_sizeView.cy / 2;		//傫قǑ傫ʂ	
	Invalidate(TRUE);	
}

void CPlotterView::OnInitialUpdate() {
	CView::OnInitialUpdate();
	//hLgƐڑꂽ
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	//ftHg̗pTCYݒ
	GetDefaultPaperSize();
}

void CPlotterView::OnVertexRead(){
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if(pDoc->m_CoordList.count > 0){
		AfxMessageBox(TEXT("łɓǂݍ܂Ă܂"));
		return;
	}
	// szFilters is a text string that includes two file name filters:
	// "*.my" for "MyType Files" and "*.*' for "All Files."
	CString szFilters = TEXT("Wt@C (*.txt)|*.txt|All Files (*.*)|*.*||");
	// Create an Open dialog; the default file name extension is ".my".
	CFileDialog fileDlg (TRUE, TEXT("txt"), TEXT("*.txt"),OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	if( fileDlg.DoModal() == IDOK ){
		CString pathName = fileDlg.GetPathName();
		CString fileName = fileDlg.GetFileTitle ();

		CMainFrame* pFrame = (CMainFrame*)AfxGetApp()->m_pMainWnd;
		CString str;
		str = TEXT("ǂݍł܂");
		pFrame->m_wndStatusBar.SetPaneText(0,str);	

		if(pDoc->m_CoordList.ReadFromFile((const char *)pathName) == FALSE){
			AfxMessageBox(TEXT("G[܂"));
			return;
		}
		pDoc->SetTitle(fileName);
		//ڑ
		pDoc->m_PolyList.Bind(&(pDoc->m_CoordList));
		FocusOnLastCoord();
		VerticesPathName = pathName;
	}
}

void CPlotterView::OnPolygonRead(){
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CMainFrame* pFrame = (CMainFrame*)AfxGetApp()->m_pMainWnd;
	CString str;
	str = TEXT("ǂݍł܂");
	pFrame->m_wndStatusBar.SetPaneText(0,str);	

	if(pDoc->m_CoordList.count < 1){
		AfxMessageBox(TEXT("Wt@Cɓǂݍł"));
		return;
	}
	if(pDoc->m_PolyList.count > 0){
		AfxMessageBox(TEXT("łɓǂݍ܂Ă܂"));
		return;
	}
	CString szFilters = TEXT("|St@C (*.txt)|*.txt|All Files (*.*)|*.*||");
	CFileDialog fileDlg (TRUE, TEXT("txt"), TEXT("*.txt"),OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	if( fileDlg.DoModal() == IDOK ){
		CString pathName = fileDlg.GetPathName();
		CCoord res = pDoc->m_PolyList.ReadFromFile((const char *)pathName);
		CString str;
		int res_v = (int)res.y;
		switch((int)res.x){
	// res.x = -2		t@CI[vÕG[
	// res.x = -1		t@CJȂ
	// res.x = 1		|SIDd
	// res.x = 2		WID͂Ȃ
	// res.x = 3		WIDŒǉɎs
	// res.x = 0		
			case -2:
				AfxMessageBox(TEXT("Wt@Cǂݍ܂Ă܂"));
				return;
			case -1:
				AfxMessageBox(TEXT("t@CJ܂"));
				return;
			case 1:
				str.Format("%dsڂPolyIDdĂ܂",res_v);
				AfxMessageBox(str);
				return;
			case 2:
				str.Format("%dsڂ̍WID܂",res_v);
				AfxMessageBox(str);
				return;
			case 3:
				str.Format("%dsڂ̍WID̒ǉɎs܂",res_v);
				AfxMessageBox(str);
				return;
			default:
				break;
		}
		FocusOnCurrentPolygon();
		PolygonPathName = pathName;
	}
}

void CPlotterView::OnVertexWriteRaw(){
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if(pDoc->m_CoordList.count < 1){
		AfxMessageBox(TEXT("W݂܂"));
		return;
	}
	CString szFilters = TEXT("Wt@C (*.txt)|*.txt|All Files (*.*)|*.*||");
	CFileDialog fileDlg (FALSE, TEXT("txt"), TEXT("*.txt"),OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	if( fileDlg.DoModal() == IDOK ){
		CString pathName = fileDlg.GetPathName();
		//CString fileName = fileDlg.GetFileTitle ();
		//if(pDoc->m_CoordList.bFloat){
		//	if(IDYES != AfxMessageBox(TEXT("_ȉ̃f[^܂"),MB_YESNO)) return;
		//}
		pDoc->m_CoordList.WriteToFile((const char *)pathName);
	}
}

void CPlotterView::OnVertexWrite(){
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if(pDoc->m_CoordList.count < 1){
		AfxMessageBox(TEXT("W݂܂"));
		return;
	}
	CString szFilters = TEXT("Wt@C (*.txt)|*.txt|All Files (*.*)|*.*||");
	CFileDialog fileDlg (FALSE, TEXT("txt"), TEXT("*.txt"),OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	if( fileDlg.DoModal() == IDOK ){
		CString pathName = fileDlg.GetPathName();
		//CString fileName = fileDlg.GetFileTitle ();
		if(IDYES == AfxMessageBox(TEXT("gĂȂW͍폜܂"),MB_YESNO)){
			pDoc->m_CoordList.DeleteUnused();
			pDoc->m_CoordList.WriteToFile((const char *)pathName);
		}
	}
}

void CPlotterView::OnPolygonWrite(){
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if(pDoc->m_PolyList.count < 1){
		AfxMessageBox(TEXT("|S݂܂"));
		return;
	}
	CString szFilters = TEXT("|St@C (*.txt)|*.txt|All Files (*.*)|*.*||");
	CFileDialog fileDlg (FALSE, TEXT("txt"), TEXT("*.txt"),OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	if( fileDlg.DoModal() == IDOK ){
		CString pathName = fileDlg.GetPathName();
		//CString fileName = fileDlg.GetFileTitle ();
		pDoc->m_PolyList.WriteToFile((const char *)pathName);
		pDoc->m_PolyList.DataWriteToFile((const char *)(pathName + "_area"));
	}
}

void CPlotterView::OnValidCheck(){
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CString str;
	CCoord c = pDoc->m_PolyList.WhereIntersect();
	int x = (int)(c.x);int y = (int)(c.y);
	if(x > -1){
		str.Format("|SID=%d%dĂ܂",x,y);
		::AfxMessageBox(str);
		FocusOnPolygon(x);
		return;
	}
	int i = pDoc->m_PolyList.WhereSelfTwined();
	if(i > -1){
		str.Format("|SID=%d͝Ă܂",i);
		::AfxMessageBox(str);
		FocusOnPolygon(i);
		return;
	}
	str = TEXT("I܂");
	::AfxMessageBox(str);
}
/////////////////////////////////////////////////////////////////////////////
// CMapPrinterView NẌ
/*
void CPlotterView::OnPrinterSetup(){
	((CPlotterApp*)AfxGetApp())->OnFilePrintSetup();
	GetCurrentPaperSize();				//m_sizePrintableݒ肷
	Invalidate();
	return;
}
*/
BOOL CPlotterView::OnPreparePrinting(CPrintInfo* pInfo){
	// ftHg̈A[Ԃƈ~
	return DoPreparePrinting(pInfo);
}

void CPlotterView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo){
	m_sizePrintable.cx = pDC->GetDeviceCaps(HORZRES);	//sNZP 
	m_sizePrintable.cy = pDC->GetDeviceCaps(VERTRES); 
	pInfo->SetMaxPage(1);	//Py[Wň
}

void CPlotterView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/){
	// TODO: ̌㏈ǉĂB
}

/////////////////////////////////////////////////////////////////////////////

void CPlotterView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo) {
	if(pDC->IsPrinting()){
		pDC->SetMapMode(MM_ISOTROPIC);
		//m_sizeView.cx;		//傫قǑ傫ʂ
		//m_WindowOrg;			//foCX̌_ɗ_W
		//W
		pDC->SetWindowExt(100,100);
		pDC->SetViewportExt(100,-100);
		//_
		pDC->SetWindowOrg(0,0);
		pDC->SetViewportOrg(0,m_sizePrintable.cy);
		CView::OnPrepareDC(pDC, pInfo);
	}
	else{
		pDC->SetMapMode(MM_ISOTROPIC);
		GetClientRect(m_rectClient);
		//m_sizeView.cx;		//傫قǑ傫ʂ
		//m_WindowOrg;			//foCX̌_ɗ_W
		//W
		m_Stroke = 100000/m_sizeView.cx;	//J[\ړ
		pDC->SetWindowExt(m_sizeWindows);
		pDC->SetViewportExt(m_sizeView);
		pDC->SetWindowOrg(m_WindowOrg);
		pDC->SetViewportOrg(m_rectClient.right /2,m_rectClient.bottom/2);
		//\͈͂𐄒肷邾
		m_Visible.top = (m_rectClient.bottom / 2) * m_sizeWindows.cy / m_sizeView.cy + m_WindowOrg.y;
		m_Visible.bottom = (-m_rectClient.bottom / 2) * m_sizeWindows.cy / m_sizeView.cy + m_WindowOrg.y;
		m_Visible.right = (m_rectClient.right / 2) * m_sizeWindows.cx / m_sizeView.cx + m_WindowOrg.x;
		m_Visible.left = (-m_rectClient.right / 2) * m_sizeWindows.cx / m_sizeView.cx + m_WindowOrg.x;

		CView::OnPrepareDC(pDC, pInfo);
	}
}
void CPlotterView::GetDefaultPaperSize(){
	CPrintDialog dlg(FALSE);
	if(dlg.GetDefaults()){
		//GetDefaultsAPIĂŃVXẽftHgĂ
		CDC dc;
		dc.Attach(dlg.GetPrinterDC());
		m_sizePrintable.cx = dc.GetDeviceCaps(HORZRES);
		m_sizePrintable.cy = dc.GetDeviceCaps(VERTRES);
	}
	m_rectLegion = CRect(50,m_sizePrintable.cy - 500,400, m_sizePrintable.cy - 3000);
}

void CPlotterView::GetCurrentPaperSize(){
	CPrintDialog dlg(FALSE);
	if(AfxGetApp()->GetPrinterDeviceDefaults(&(dlg.m_pd))){
		//  MFCŊǗnhĂэނ
		//@LȂ͈̂ȉ̂QiMFC̃vCx[goj
		//	pPrintDlg->hDevNames = m_hDevNames;
		//  pPrintDlg->hDevMode = m_hDevMode;
		CDC dc;
		if(dlg.GetPrinterDC() == NULL) dc.Attach(dlg.CreatePrinterDC());
		else dc.Attach(dlg.GetPrinterDC());
		m_sizePrintable.cx = dc.GetDeviceCaps(HORZRES);
		m_sizePrintable.cy = dc.GetDeviceCaps(VERTRES);
	}
	m_rectLegion = CRect(50,m_sizePrintable.cy - 500,400, m_sizePrintable.cy - 3000);
}

void CPlotterView::OnPageSetup(){
	CPageSetupDialog psd(PSD_INTHOUSANDTHSOFINCHES | PSD_MARGINS | PSD_ENABLEPAGEPAINTHOOK, this);
	// Initialize margins
	psd.m_psd.rtMargin.top = 100;
	psd.m_psd.rtMargin.left = 100;
	psd.m_psd.rtMargin.right = 100;
	psd.m_psd.rtMargin.bottom = 100;

	if( IDOK == psd.DoModal() ) {
		// Propagate changes to the app
		AfxGetApp()->SelectPrinter(psd.m_psd.hDevNames, psd.m_psd.hDevMode);
		//GetCurrentPaperSize();
		//CMainFrame* pFrame = (CMainFrame*)((CMDIChildWnd*)GetParent())->GetMDIFrame();
		//m_DialogInfo.Duplicate(&(pFrame->m_GeneralInfo));
		//m_DialogInfo.SetDimension(m_sizePrintable);
	}
	else
      TRACE("CommDlgExtendedError returned error %d from CPageSetupDialog::DoModal().\n", (int)CommDlgExtendedError() );
	Invalidate();
}

void CPlotterView::OnFitPaper(){
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if(pDoc->m_CoordList.count < 1){
		AfxMessageBox(TEXT("W݂܂"));
		return;
	}
	CCoord pos;
	pos.x = m_sizePrintable.cx;pos.y = m_sizePrintable.cy;
	pDoc->m_CoordList.FitToSize(pos);
	pDoc->m_PolyList.ArrayUnset();
	// TODO: ɃR}h nh R[hǉ܂B
	OnFilePrintPreview();
}

void CPlotterView::OnColorChange(){
	if(!m_bColorDialogOn){
		if(m_pColor->GetSafeHwnd() == 0){
			CPlotterDoc* pDoc = GetDocument();
			ASSERT_VALID(pDoc);
			//m_pColor->SetDataRange(1,100);
			m_pColor->m_EnableSample = TRUE;
			m_pColor->ModelessCreate();
			m_bColorDialogOn = TRUE;
		}
	}
	else{
		m_pColor->DestroyWindow();
		m_bColorDialogOn = FALSE;
	}
}
LONG CPlotterView::OnClosed(UINT wParam, LONG lParam){
	m_pColor->DestroyWindow();
	m_bColorDialogOn = FALSE;
	return 0;
}

LONG CPlotterView::OnNewColorRedraw(UINT wParam, LONG lParam){
	Invalidate();
	return 1;
}

BOOL CPlotterView::DestroyWindow() {
	if(m_bColorDialogOn){
		m_pColor->DestroyWindow();
		m_bColorDialogOn = FALSE;
	}
	return CView::DestroyWindow();
}

void CPlotterView::OnDataRead(){
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if(pDoc->m_CoordList.count < 1){
		AfxMessageBox(TEXT("Wt@Cɓǂݍł"));
		return;
	}
	if(pDoc->m_PolyList.count < 1){
		AfxMessageBox(TEXT("|St@Cɓǂݍł"));
		return;
	}
	CCoord c;
	CString szFilters = TEXT("f[^t@C (*.txt)|*.txt|All Files (*.*)|*.*||");
	CFileDialog fileDlg (TRUE, TEXT("txt"), TEXT("*.txt"),OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	if( fileDlg.DoModal() == IDOK ){
		CString pathName = fileDlg.GetPathName();
		//CString fileName = fileDlg.GetFileTitle ();
		c = pDoc->m_PolyList.ReadDataFile((const char *)pathName);
		//sĂ(0,100)default range
		m_DataRangeMax = m_LegionRangeMax = c.x;
		m_DataRangeMin = m_LegionRangeMin = c.y;
		m_pColor->SetDataRange(m_LegionRangeMin,m_LegionRangeMax);
	}
}
void CPlotterView::OnEditShiftMagnify(){
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CMainFrame* pFrame = (CMainFrame*)AfxGetApp()->m_pMainWnd;
	CString str;
	CShiftPolygon Dlg;
	Dlg.m_shiftx = Dlg.m_shifty = 0;
	Dlg.m_Magnify = 1;
	Dlg.m_bBoth = TRUE;
	CCoord p;
	if(Dlg.DoModal() == IDOK){
		str = TEXT("Wg債Ă܂");
		pFrame->m_wndStatusBar.SetPaneText(0,str);	
		pDoc->m_CoordList.Expand(Dlg.m_Magnify);

		str = TEXT("W𕽍sړĂ܂");
		pFrame->m_wndStatusBar.SetPaneText(0,str);	
		p.x = Dlg.m_shiftx;p.y = Dlg.m_shifty;
		pDoc->m_CoordList.Shift(p);
		pDoc->m_PolyList.ArrayUnset();
		if(Dlg.m_bBoth){
			str = TEXT("C[Wg債Ă܂");
			pFrame->m_wndStatusBar.SetPaneText(0,str);	
			pDoc->m_LayerCoordList.Expand(Dlg.m_Magnify);
			str = TEXT("C[W𕽍sړĂ܂");
			pFrame->m_wndStatusBar.SetPaneText(0,str);	
			pDoc->m_LayerCoordList.Shift(p);
			pDoc->m_LayerPolyList.ArrayUnset();
		}
		FocusOnCurrentPolygon();
		InvalidateRect(NULL);
	}
}
void CPlotterView::FocusOnCurrentPolygon(){
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CCoord p = pDoc->m_PolyList.GetCurrentPolyPosition();
	m_WindowOrg.x = p.x;
	m_WindowOrg.y = p.y;
	InvalidateRect(NULL);
}
void CPlotterView::FocusOnPolygon(int i){
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	POSITION pos;
	CPolygon* pPoly;
	pos = pDoc->m_PolyList.GetHeadPosition();
	while(pos != NULL){
		pPoly = pDoc->m_PolyList.GetNext(pos);
		if(pPoly->PolyID == i) pDoc->m_PolyList.pCurrentPoly = pPoly;
	}
	FocusOnCurrentPolygon();
}
void CPlotterView::FocusOnLastCoord(){
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	POSITION pos = pDoc->m_CoordList.GetTailPosition();
	CCoord* p = pDoc->m_CoordList.GetPrev(pos);
	m_WindowOrg.x = p->x;
	m_WindowOrg.y = p->y;
	InvalidateRect(NULL);
}

void CPlotterView::OnOption(){
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	Option Dlg;
	Dlg.m_PointSize = m_PointSize;
	Dlg.m_UpperLimit = m_UpperLimit;
	Dlg.m_LowerLimit = m_LowerLimit;
	Dlg.m_bName = m_bName;
	if(pDoc->m_PolyList.m_bData){
		Dlg.m_bData = TRUE;
		Dlg.m_dDataMax = m_DataRangeMax;
		Dlg.m_dDataMin = m_DataRangeMin;
		Dlg.m_dMax = m_LegionRangeMax;
		Dlg.m_dMin = m_LegionRangeMin;
	}
	Dlg.m_FontSize = m_FontSize;
	Dlg.m_LTop = m_rectLegion.top;
	Dlg.m_LBottom = m_rectLegion.bottom;
	Dlg.m_LLeft = m_rectLegion.left;
	Dlg.m_LRight = m_rectLegion.right;
	Dlg.rect.right = m_sizePrintable.cx;
	Dlg.rect.top = m_sizePrintable.cy;
	Dlg.rect.left = Dlg.rect.bottom = 0;
	Dlg.m_bBoundary = m_bBoundary;
	Dlg.m_BoundarySize = m_BoundarySize;
	Dlg.m_BoundaryUnit = m_BoundaryUnit;
	if(Dlg.DoModal() == IDOK){
		m_PointSize = Dlg.m_PointSize;
		m_UpperLimit = Dlg.m_UpperLimit;
		m_LowerLimit = Dlg.m_LowerLimit;
		m_bName = Dlg.m_bName;
		m_FontSize = Dlg.m_FontSize;
		m_rectLegion.top = Dlg.m_LTop;
		m_rectLegion.bottom = Dlg.m_LBottom;
		m_rectLegion.left = Dlg.m_LLeft;
		m_rectLegion.right = Dlg.m_LRight;
		if(Dlg.m_dMax >= m_DataRangeMax) m_LegionRangeMax = Dlg.m_dMax;
		if(Dlg.m_dMin <= m_DataRangeMin) m_LegionRangeMin = Dlg.m_dMin;
		m_pColor->SetDataRange(m_LegionRangeMin,m_LegionRangeMax);
		m_bBoundary = Dlg.m_bBoundary;
		m_BoundarySize = Dlg.m_BoundarySize;
		m_BoundaryUnit = Dlg.m_BoundaryUnit;
		InvalidateRect(NULL);
	}
}

void CPlotterView::OnReferenceRead(){
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CMainFrame* pFrame = (CMainFrame*)AfxGetApp()->m_pMainWnd;
	CString str;
	str = TEXT("ǂݍł܂");
	pFrame->m_wndStatusBar.SetPaneText(0,str);	

	// szFilters is a text string that includes two file name filters:
	// "*.my" for "MyType Files" and "*.*' for "All Files."
	CString szFilters = TEXT("Wt@C (*.txt)|*.txt|All Files (*.*)|*.*||");

   // Create an Open dialog; the default file name extension is ".my".
	CFileDialog fileDlg (TRUE, TEXT("txt"), TEXT("*.txt"),OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	if( fileDlg.DoModal() == IDOK ){
		CString pathName = fileDlg.GetPathName();
		pDoc->m_CoordList.IDIgnoreReadFromFile((const char *)pathName);
	}
	str = TEXT("ǂݍ݂܂");
	pFrame->m_wndStatusBar.SetPaneText(0,str);	
}

void CPlotterView::OnNocheckVerttexRead()
{
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CMainFrame* pFrame = (CMainFrame*)AfxGetApp()->m_pMainWnd;
	CString str;
	str = TEXT("ǂݍł܂");
	pFrame->m_wndStatusBar.SetPaneText(0,str);	


	if(pDoc->m_CoordList.count > 0){
		AfxMessageBox(TEXT("łɓǂݍ܂Ă܂"));
		return;
	}
	// szFilters is a text string that includes two file name filters:
	// "*.my" for "MyType Files" and "*.*' for "All Files."
	CString szFilters = TEXT("Wt@C (*.txt)|*.txt|All Files (*.*)|*.*||");

   // Create an Open dialog; the default file name extension is ".my".
	CFileDialog fileDlg (TRUE, TEXT("txt"), TEXT("*.txt"),OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	if( fileDlg.DoModal() == IDOK ){
		CString pathName = fileDlg.GetPathName();
		//CString fileName = fileDlg.GetFileTitle ();
		if(pDoc->m_CoordList.NoCheckReadFromFile((const char *)pathName) == FALSE){
			AfxMessageBox(TEXT("G[܂"));
			return;
		}
		//ڑ
		pDoc->m_PolyList.Bind(&(pDoc->m_CoordList));
		FocusOnLastCoord();
		VerticesPathName = pathName;
	}
}

void CPlotterView::OnNocheckPolygonRead()
{
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CMainFrame* pFrame = (CMainFrame*)AfxGetApp()->m_pMainWnd;
	CString str;
	str = TEXT("ǂݍł܂");
	pFrame->m_wndStatusBar.SetPaneText(0,str);	

	if(pDoc->m_CoordList.count < 1){
		AfxMessageBox(TEXT("Wt@Cɓǂݍł"));
		return;
	}
	if(pDoc->m_PolyList.count > 0){
		AfxMessageBox(TEXT("łɓǂݍ܂Ă܂"));
		return;
	}
	CString szFilters = TEXT("|St@C (*.txt)|*.txt|All Files (*.*)|*.*||");
	CFileDialog fileDlg (TRUE, TEXT("txt"), TEXT("*.txt"),OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	if( fileDlg.DoModal() == IDOK ){
		CString pathName = fileDlg.GetPathName();
		CCoord res = pDoc->m_PolyList.NoCheckReadFromFile((const char *)pathName);
		CString str;
		int res_v = (int)res.y;
		switch((int)res.x){
	// res.x = -2		t@CI[vÕG[
	// res.x = -1		t@CJȂ
	// res.x = 1		|SIDd
	// res.x = 2		WID͂Ȃ
	// res.x = 3		WIDŒǉɎs
	// res.x = 0		
			case -2:
				AfxMessageBox(TEXT("Wt@Cǂݍ܂Ă܂"));
				return;
			case -1:
				AfxMessageBox(TEXT("t@CJ܂"));
				return;
			case 1:
				str.Format("%dsڂPolyIDdĂ܂",res_v);
				AfxMessageBox(str);
				return;
			case 2:
				str.Format("%dsڂ̍WID܂",res_v);
				AfxMessageBox(str);
				return;
			case 3:
				str.Format("%dsڂ̍WID̒ǉɎs܂",res_v);
				AfxMessageBox(str);
				return;
			default:
				break;
		}
		FocusOnCurrentPolygon();
		PolygonPathName = pathName;
	}
}


void CPlotterView::OnTranslate()
{
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if(pDoc->m_CoordList.count < 1){
		AfxMessageBox(TEXT("W݂܂"));
		return;
	}

	// ړI DLL [h
	HINSTANCE hDLL = LoadLibrary( _T("proj.dll") );
	if(hDLL == NULL){
		AfxMessageBox(TEXT("PROJ.DLL܂"));
		return;
	}

	pF_pj_init pF_init = (pF_pj_init) GetProcAddress(hDLL, "pj_init");
	pF_pj_fwd pF_fwd = (pF_pj_fwd) GetProcAddress(hDLL, "pj_fwd");
	//pF_pj_error pF_error = (pF_pj_error) GetProcAddress(hDLL, "pj_strerrno");
	pF_pj_free pF_free = (pF_pj_free) GetProcAddress(hDLL, "pj_free");
	if(!pF_init){
		FreeLibrary(hDLL);
		AfxMessageBox(TEXT("֐܂"));
		return;
	}
	CString str;

	char** strParam;
	char *pStr;
	int i,j;
	int numParam;
	int num;
	int size;
	CProjection Dlg;
	PJ* proj_param; /* eϊ\ */
	PJ_LP idata;       /* ϊoxܓx */
	PJ_XY odata;       /* ϊXY       */

	// VWIIñp[^
	//Dlg.m_Param = "+proj=tmerc +lat_0=33 +lon_0=131 +k=0.999900 +x_0=0 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs";
	if( Dlg.DoModal() == IDOK ){

		//p[^[̕
		numParam = 1;
		pStr = Dlg.m_Param.GetBuffer(300);
		for(i = 0;*(pStr + i) != NULL;i++) if(*(pStr + i) == ' ') numParam++;
		strParam = new char* [numParam + 1];
		j = 0;
		for(i = 0;i < numParam;i++){
			size = 0;
			for(;;j++){
				if((*(pStr + j) == ' ') || (*(pStr + j) == NULL)){
					j++;
					*(strParam + i) = new char[size + 1];
					break;
				}
				size++;
			}
		}
		*(strParam + i) = NULL;
		num = 0;
		for(i = j = 0;;i++){
			if((*(pStr + i) == ' ') || (*(pStr + i) == NULL)){
				*(pStr + i) = NULL;
				strcpy(*(strParam + num),pStr + j);
				j = i + 1;
				if(num >= numParam - 1) break;
				num++;
			}
		}
		Dlg.m_Param.ReleaseBuffer();

		// PJ*
		proj_param = (*pF_init)(numParam, (char **)strParam);
		if(proj_param == NULL){
			AfxMessageBox(TEXT("Ɏs܂"));
			for(i = 0;i < numParam;i++){
				delete [](*(strParam + i));
			}
			delete [] strParam;
			FreeLibrary(hDLL);
			return;
		}

		CCoord * pCoord;
		POSITION POS = pDoc->m_CoordList.GetHeadPosition();
		while(POS != NULL){
			pCoord = pDoc->m_CoordList.GetNext(POS);
			/* ϊoxܓxZbg */
			idata.lam = pCoord->x;
			idata.phi = pCoord->y;
/*			if((idata.lam >= 180) || (idata.lam <= -180) || (idata.phi >= 90) || (idata.phi <= -90)){
				AfxMessageBox(TEXT("̍W͈͊Oł"));
				pF_free(proj_param);
				for(i = 0;i < numParam;i++){
					delete [](*(strParam + i));
				}
				delete [] strParam;
				FreeLibrary(hDLL);
				return;
			}
			/* WAɕϊ         */
			idata.lam *= DEG_TO_RAD;
			idata.phi *= DEG_TO_RAD;

			odata = pF_fwd(idata, proj_param);
			pCoord->x = odata.x;
			pCoord->y = odata.y;

			str.Format("(%f,%f) is projected to (%f,%f)\n",idata.lam,idata.phi,odata.x,odata.y);
			OutputDebugString(str);
		}
		pDoc->m_PolyList.ArrayUnset();

		pF_free(proj_param);
		for(i = 0;i < numParam;i++){
			delete [](*(strParam + i));
		}
		delete [] strParam;
	}
	FreeLibrary(hDLL);
}

void CPlotterView::OnChangeMode(UINT nID){
	m_Mode = nID - ID_POINT_MODE;
	Invalidate(TRUE);
}

void CPlotterView::OnUpdateModeMenu(CCmdUI* p){
	switch(p->m_nID){
		case ID_POINT_MODE:
			p->SetCheck(p->m_nID == m_Mode + ID_POINT_MODE);
			break;
		case ID_POINT_MODE + 1:
			p->SetCheck(p->m_nID == m_Mode + ID_POINT_MODE);
			break;
		case ID_POINT_MODE + 2:
			p->SetCheck(p->m_nID == m_Mode + ID_POINT_MODE);
			break;
		case ID_POINT_MODE + 3:
			p->SetCheck(p->m_nID == m_Mode + ID_POINT_MODE);
			break;
		case ID_LAYER_SHOW:
			p->SetCheck(m_bLayer);
			break;
	}
}

void CPlotterView::OnLayerShow(){
	m_bLayer = m_bLayer ? FALSE : TRUE;
	if(m_bLayer) InvalidateRect(NULL);
}

void CPlotterView::OnLayerVertex(){
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CMainFrame* pFrame = (CMainFrame*)AfxGetApp()->m_pMainWnd;
	CString str;
	str = TEXT("ǂݍł܂");
	pFrame->m_wndStatusBar.SetPaneText(0,str);	

	if(pDoc->m_LayerCoordList.count > 0){
		AfxMessageBox(TEXT("łɓǂݍ܂Ă܂"));
		return;
	}
	// szFilters is a text string that includes two file name filters:
	// "*.my" for "MyType Files" and "*.*' for "All Files."
	CString szFilters = TEXT("Wt@C (*.txt)|*.txt|All Files (*.*)|*.*||");
   // Create an Open dialog; the default file name extension is ".my".
	CFileDialog fileDlg (TRUE, TEXT("txt"), TEXT("*.txt"),OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	if( fileDlg.DoModal() == IDOK ){
		CString pathName = fileDlg.GetPathName();
		//CString fileName = fileDlg.GetFileTitle ();
		if(pDoc->m_LayerCoordList.ReadFromFile((const char *)pathName) == FALSE){
			AfxMessageBox(TEXT("G[܂"));
			return;
		}
		//ڑ
		pDoc->m_LayerPolyList.Bind(&(pDoc->m_LayerCoordList));
	}
}

void CPlotterView::OnLayerPolygon(){
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CMainFrame* pFrame = (CMainFrame*)AfxGetApp()->m_pMainWnd;
	CString str;
	str = TEXT("ǂݍł܂");
	pFrame->m_wndStatusBar.SetPaneText(0,str);	

	if(pDoc->m_LayerCoordList.count < 1){
		AfxMessageBox(TEXT("Wt@Cɓǂݍł"));
		return;
	}
	if(pDoc->m_LayerPolyList.count > 0){
		AfxMessageBox(TEXT("łɓǂݍ܂Ă܂"));
		return;
	}
	CString szFilters = TEXT("|St@C (*.txt)|*.txt|All Files (*.*)|*.*||");
	CFileDialog fileDlg (TRUE, TEXT("txt"), TEXT("*.txt"),OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	if( fileDlg.DoModal() == IDOK ){
		CString pathName = fileDlg.GetPathName();
		CCoord res = pDoc->m_LayerPolyList.ReadFromFile((const char *)pathName);
		CString str;
		int res_v = (int)res.y;
		switch((int)res.x){
	// res.x = -2		t@CI[vÕG[
	// res.x = -1		t@CJȂ
	// res.x = 1		|SIDd
	// res.x = 2		WID͂Ȃ
	// res.x = 3		WIDŒǉɎs
	// res.x = 0		
			case -2:
				AfxMessageBox(TEXT("Wt@Cǂݍ܂Ă܂"));
				return;
			case -1:
				AfxMessageBox(TEXT("t@CJ܂"));
				return;
			case 1:
				str.Format("%dsڂPolyIDdĂ܂",res_v);
				AfxMessageBox(str);
				return;
			case 2:
				str.Format("%dsڂ̍WID܂",res_v);
				AfxMessageBox(str);
				return;
			case 3:
				str.Format("%dsڂ̍WID̒ǉɎs܂",res_v);
				AfxMessageBox(str);
				return;
			default:
				break;
		}
	}
}

void CPlotterView::OnIdRename(){
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CNewPolygon Dlg;
	if(Dlg.DoModal() == IDOK){
		if(!pDoc->m_PolyList.RenameCurrentPolygon(Dlg.m_ID)){
			CString str = TEXT("IDdŒǉł܂ł");
			::AfxMessageBox(str);
		}
	}
}

void CPlotterView::OnGroupDelete(){
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CGroupDelete Dlg;
	Dlg.m_From = 1;
	Dlg.m_To = 0;
	if(Dlg.DoModal() == IDOK){
		CString str = TEXT("{ɍ폜H");
		if(::AfxMessageBox(str,MB_YESNO) == IDYES){
			pDoc->m_PolyList.RemovePolygonGroup(Dlg.m_From,Dlg.m_To);
		InvalidateRect(NULL);
		}
	}
}

void CPlotterView::OnRButtonDown(UINT nFlags, CPoint point) {
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CClientDC dc(this);
	OnPrepareDC(&dc);
	dc.DPtoLP(&point);
	CCoord POS;
	CString str;
	//WϊI
	switch(m_Mode){
		case 0://W[h
			//VtgȂ폜
			POS.x = point.x;
			POS.y = point.y;
			if(nFlags & MK_SHIFT){	//폜
				pDoc->m_CoordList.Remove(pDoc->m_CoordList.UnusedNearestPointID(POS));
			}else{
				POS.ID = pDoc->m_CoordList.ValidNewID();
				pDoc->m_CoordList.Add(POS);
			}
			break;
		case 1://xNg[h
			//VtgȂ폜
			//Rg[ȂNbNŐV|S
			//Rg[{VtgȂ|S폜
			POS.x = point.x;
			POS.y = point.y;
			if((nFlags & MK_SHIFT) && !(nFlags & MK_CONTROL)){	//폜
				pDoc->m_PolyList.RemovePosFromCurrentPoly();
			}
			if(!(nFlags & MK_SHIFT) && !(nFlags & MK_CONTROL)){	//ǉ
				pDoc->m_PolyList.AddPosToCurrentPoly(POS);
				/*
				if(!pDoc->m_PolyList.NoIntersect()){
					str = TEXT("̃|SƌF܂");
					::AfxMessageBox(str);
					pDoc->m_PolyList.RemovePosFromCurrentPoly();
				}
				if(!pDoc->m_PolyList.pCurrentPoly->NoSelfTwined()){
					str = TEXT("ꂽ|SF܂");
					if(::AfxMessageBox(str,MB_YESNO) == IDYES){
						pDoc->m_PolyList.RemovePosFromCurrentPoly();
					}			
				}*/
			}
			if((nFlags & MK_SHIFT) && (nFlags & MK_CONTROL)){	//|S폜
					str = TEXT("Jg|S폜H");
					if(::AfxMessageBox(str,MB_YESNO) == IDYES){
						pDoc->m_PolyList.RemoveCurrentPolygon();
					}
			}
			if(!(nFlags & MK_SHIFT) && (nFlags & MK_CONTROL)){	//|Sǉ
				CNewPolygon Dlg;
				if(Dlg.DoModal() == IDOK){
					if(!pDoc->m_PolyList.AddNewPolygon(Dlg.m_ID)){
						CString str = TEXT("IDdŒǉł܂ł");
						::AfxMessageBox(str);
					}
				}
			}
			pDoc->UpdateStatus();
			break;
		case 2://{[h
			m_WindowOrg = point;
			break;
	}
	InvalidateRect(NULL);
	CView::OnRButtonDown(nFlags, point);
}
void CPlotterView::OnLButtonDown(UINT nFlags, CPoint point) {
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CClientDC dc(this);
	OnPrepareDC(&dc);
	dc.DPtoLP(&point);
	CCoord POS;
	CString str;
	//WϊI
	switch(m_Mode){
		case 0://W[h
			break;
		case 1://xNg[h
			//Rg[ȂNbNōăO[sO
			POS.x = point.x;
			POS.y = point.y;
			if(!(nFlags & MK_SHIFT) && (nFlags & MK_CONTROL)){	//ǉ
				int ID = pDoc->m_PolyList.pCurrentPoly->PolyID;
				pDoc->m_PolyList.RemoveCurrentPolygon();
				if(!pDoc->m_PolyList.AddNewPolygon(ID)){
					CString str = TEXT("IDdŒǉł܂ł");
					::AfxMessageBox(str);
				}
			}
			pDoc->UpdateStatus();
			break;
		case 2://{[h
			break;
	}
	InvalidateRect(NULL);
	CView::OnLButtonDown(nFlags, point);
}

void CPlotterView::OnMouseMove(UINT nFlags, CPoint point) {
	CView::OnMouseMove(nFlags, point);
	CMainFrame* pFrame = (CMainFrame*)AfxGetApp()->m_pMainWnd;
	CClientDC dc(this);
	OnPrepareDC(&dc);
	dc.DPtoLP(&point);
	m_Pointer = point;
	CString t;
	t.Format(TEXT("W(x %d,y %d ) "),m_Pointer.x,m_Pointer.y);
	pFrame->m_wndStatusBar.SetPaneText(0,t);	
}
void CPlotterView::OnForcedsave(){
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if(!PolygonPathName.IsEmpty()){
		pDoc->m_PolyList.WriteToFile(PolygonPathName);
	}
	if(!VerticesPathName.IsEmpty()){
		if(IDYES == AfxMessageBox(TEXT("gĂȂW͍폜܂"),MB_YESNO)){
			pDoc->m_CoordList.DeleteUnused();
			pDoc->m_CoordList.WriteToFile(VerticesPathName);
		}
	}
}

void CPlotterView::OnOpencarto(){
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CFolderDialog Dlg;
	if(Dlg.DoModal() == IDOK){
		CString Folder = Dlg.GetFolderPath();
		VerticesPathName = Folder + _T("data_vertices.txt");
		PolygonPathName = Folder + _T("data_polygon.txt");
		pDoc->m_CoordList.ReadFromFile(VerticesPathName);
		pDoc->m_PolyList.Bind(&(pDoc->m_CoordList));
		pDoc->m_PolyList.ReadFromFile(PolygonPathName);
		FocusOnCurrentPolygon();
	}
}

void CPlotterView::OnOpendeformed()
{
	CPlotterDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CFolderDialog Dlg;
	if(Dlg.DoModal() == IDOK){
		CString Folder = Dlg.GetFolderPath();
		VerticesPathName = Folder + _T("data_vertices_deformed.txt");
		PolygonPathName = Folder + _T("data_polygon.txt");
		pDoc->m_CoordList.ReadFromFile(VerticesPathName);
		pDoc->m_PolyList.Bind(&(pDoc->m_CoordList));
		pDoc->m_PolyList.ReadFromFile(PolygonPathName);
		FocusOnCurrentPolygon();
	}
}
