#include "StdAfx.h"
#include "Polygon.h"

//*********************************************************
// _ p L e(a,b) ̍Eǂ瑤ɂ邩ׂB
// _ p L e ́@Eɂꍇ  1 A
// @   @L e ̒ɂꍇ  0 A
// @   @L e ́@ɂꍇ -1 ԂB
//*********************************************************
int side(CCoord* p,CCoord* pLineStart,CCoord* pLineEnd)
{
	// L (pLineStart,p), (pLineStart,pLineEnd) ̊Oς߂
	double n = p->x * (pLineStart->y - pLineEnd->y) + pLineStart->x * (pLineEnd->y - p->y) + pLineEnd->x * (p->y - pLineStart->y);
	if ( n > 0 ) return  1; // E
	else if ( n < 0 ) return -1; // 
	else              return  0; // 
}

//*********************************************************
// _ a, b  e ׂő݂邩肷B
// _ a, b  e ׂłΐ^AȂ΋UԂ
// _ɑ݂ꍇɂ́wׂxƔfB
//*********************************************************
BOOL straddle(CCoord* pLineStart,CCoord* pLineEnd,CCoord* a, CCoord* b){
	// _ a, b ݂ɗL e ̈قȂ鑤ɂȂ΁A
	// _ a, b ͐ e ׂB
	return 0 >= side(a,pLineStart,pLineEnd) * side(b,pLineStart,pLineEnd);
}

//*********************************************************
//  e1, e2 邩肷B
//  e1, e2 ΐ^AȂ΋UԂ
//*********************************************************
BOOL intersect(CCoord* pLineStart1,CCoord* pLineEnd1,CCoord* pLineStart2,CCoord* pLineEnd2)
{
	//  e1, e2 ΊpƂQ̒`ȂꍇA e1, e2 邱Ƃ͂ȂB
	if ( min(pLineStart1->x, pLineEnd1->x) > max(pLineStart2->x, pLineEnd2->x) ) return 0;
	if ( min(pLineStart1->y, pLineEnd1->y) > max(pLineStart2->y, pLineEnd2->y) ) return 0;
	if ( min(pLineStart2->x, pLineEnd2->x) > max(pLineStart1->x, pLineEnd1->x) ) return 0;
	if ( min(pLineStart2->y, pLineEnd2->y) > max(pLineStart1->y, pLineEnd1->y) ) return 0;
	//  e2  e1 ׂAA e1  e2 ׂȂ΁A e1, e2 ͌B
	return straddle(pLineStart1,pLineEnd1,pLineStart2,pLineEnd2) && straddle(pLineStart2,pLineEnd2,pLineStart1,pLineEnd1);
}

BOOL CPolygon::NoSelfTwined(){
	if(pCoordList == NULL) return NULL;
	if(count < 4) return TRUE;
	//gŝĂȂǂ肷
	int current1,next1;
	int current2,next2;
	int i,j;
	for(i = 0;i < count;i++){
		current1=i;
		next1 = (i == count - 1) ? 0 : i + 1;
		for(j = i + 2;j < count;j++){
			current2 = j;
			next2 = (j == count - 1) ? 0 : j + 1;
			if(current1 == next2) continue;//AɂȂO
			if(intersect(pCoordList->GetAt(m_IDlist.GetAt(current1)),pCoordList->GetAt(m_IDlist.GetAt(next1)),
				pCoordList->GetAt(m_IDlist.GetAt(current2)),pCoordList->GetAt(m_IDlist.GetAt(next2))))
				return FALSE;
		}
	}
	return TRUE;
}

int CPolygon::InPolygon(CCoord Pos){
	if(pCoordList == NULL) return NULL;
	//W̓|Sɂ邩i1,-1jڂꍇ0
	int res,current,next;
	int c = 0;
	if(count < 2) return -1;
	for(int i = 0;i < count;i++){
		current=i;
		next = (i == count - 1) ? 0 : i + 1;
		res = IsCrossing(Pos,pCoordList->GetAt(m_IDlist.GetAt(current)),pCoordList->GetAt(m_IDlist.GetAt(next)));
		if(res == 99) return 0;
		else c = c + res;
		if((c > 2) || (c < -2)){
			OutputDebugString("error: |Sł͂Ȃ\n");
			return NULL;
		}
	}
	if((c == 2) || (c == -2)) return 1;
	return -1;
}
int CPolygon::IsCrossing(CCoord Pos, CCoord* p1, CCoord* p2){
	//Wx,y͉EłQ_ԂԐƌ邩
	//ォ牺ɓ˂		return  2
	//ɓ˂		return -2
	//ォ牺ɐڂ@@		return  1
	//ɐڂ			return -1
	//ڂȂƂ				return  0
	//̎				return  99
	double res;
	double x = Pos.x;
	double y = Pos.y;
	if((p1->y - y)*(p2->y - y) > 0)		//悤Ȃ
			return 0;
	if((p1->y == y)||(p2->y == y)){	//ڂĂ
		if(p1->y == p2->y){
			return ((p1->x - x)*(p2->x - x) <= 0) ? 99 : 0;
		}
		if(p1->y == y){
			if(p1->x < x) return 0;
			if(p1->x == x) return 99;
			return (p1->y > p2->y) ? 1 : -1;
		}
		if(p2->y == y){
			if(p2->x < x) return 0;
			if(p2->x == x) return 99;
			return (p1->y > p2->y) ? 1 : -1;
		}
	}
	//ꍇ̌_XW
	res = (double)(p1->x - p2->x) * (double)(y - p1->y) / (double)(p1->y - p2->y) + (double)p1->x;	//_
	if(res == x) return 99;
	if(res < x) return 0;
	return (p1->y > p2->y) ? 2 : -2;
}

BOOL CPolyList::AddNewPolygon(int PolyID){
	if(pCoordList == NULL) return FALSE;
	CPolygon* pPos;
	//d͋Ȃ
	POSITION pos = GetHeadPosition();
	while( pos != NULL ){
		pPos = GetNext(pos);
		if(pPos->PolyID == PolyID){
			OutputDebugString("CPolyList::AddNewPolygon polyIDd\n");
			return FALSE;
		}
	}
	//
	pCurrentPoly = pPos = new CPolygon;
	pPos->Bind(pCoordList);
	pPos->PolyID = PolyID;
	m_Polylist.AddTail(pPos);
	count++;
	return TRUE;
}
BOOL CPolyList::RenameCurrentPolygon(int PolyID){
	if(pCoordList == NULL) return FALSE;
	CPolygon* pPos;
	//d͋Ȃ
	POSITION pos = GetHeadPosition();
	while( pos != NULL ){
		pPos = GetNext(pos);
		if(pPos->PolyID == PolyID){
			OutputDebugString("CPolyList::RenameCurrentPolygon polyIDd\n");
			return FALSE;
		}
	}
	pCurrentPoly->PolyID = PolyID;
	return TRUE;
}
BOOL CPolyList::RemovePolygonGroup(int From,int To){
	if(pCoordList == NULL) return FALSE;
	if(count == 0) return TRUE;
	POSITION posA,posB;
	CPolygon* pPos;
	for(posA = GetHeadPosition(); ( posB = posA ) != NULL;){
		pPos = GetNext(posA);
		if((pPos->PolyID >= From) && (pPos->PolyID <= To)){
			m_Polylist.RemoveAt(posB);
			delete pPos;
			count--;
		}
	}
	if(count == 0) pCurrentPoly = NULL;
	else{
		posA = GetTailPosition();
		pCurrentPoly = GetNext(posA);
	}
	return TRUE;
}
BOOL CPolyList::NoCheckAddNewPolygon(int PolyID){
	if(pCoordList == NULL) return FALSE;
	CPolygon* pPos;
	pCurrentPoly = pPos = new CPolygon;
	pPos->Bind(pCoordList);
	pPos->PolyID = PolyID;
	m_Polylist.AddTail(pPos);
	count++;
	return TRUE;
}
BOOL CPolyList::RemoveCurrentPolygon(){
	if(pCoordList == NULL) return FALSE;
	if(count == 0) return TRUE;
	POSITION posA,posB;
	CPolygon* pPos;
	for(posA = GetHeadPosition(); ( posB = posA ) != NULL;){
		pPos = GetNext(posA);
		if(pPos == pCurrentPoly){
			m_Polylist.RemoveAt(posB);
			delete pPos;
			count--;
			if(count == 0) pCurrentPoly = NULL;
			else{
				posA = GetTailPosition();
				pCurrentPoly = GetNext(posA);
			}
			return TRUE;
		}
	}
	return FALSE;
}

BOOL CPolyList::ChangeCurrentPolygon(CCoord pos){
	if(pCoordList == NULL) return FALSE;
	return (pCurrentPoly = NearestPolygon(pos)) != NULL;
}


POSITION CPolyList::GetHeadPosition(){return m_Polylist.GetHeadPosition();}
POSITION CPolyList::GetTailPosition(){return m_Polylist.GetTailPosition();}
CPolygon* CPolyList::GetNext(POSITION& pos){return (CPolygon*)m_Polylist.GetNext(pos);}
CPolygon* CPolyList::GetPrev(POSITION& pos){return (CPolygon*)m_Polylist.GetPrev(pos);}
CPolygon* CPolyList::GetAt(POSITION& pos){return (CPolygon*)m_Polylist.GetAt(pos);}

CPolyList::~CPolyList(){
	POSITION pos = m_Polylist.GetHeadPosition();
	while( pos != NULL ){
		delete (CPolygon*)m_Polylist.GetNext(pos);
	}
	m_Polylist.RemoveAll();
}

CPolygon::~CPolygon(){
	if((pCoordList == NULL) || (pCoordList->bAlive == FALSE))return;
	for(int i = 0;i<count;i++){
		--(pCoordList->GetAt(m_IDlist.GetAt(i))->count);
	}
	if(m_PointArray != NULL) delete [] m_PointArray;
	m_IDlist.RemoveAll();
}

BOOL CPolygon::AddTail(int ID){
	if((pCoordList == NULL) || (pCoordList->bAlive == FALSE)){
		return FALSE;
	}
	//_邱ƂۏႷ
	if(pCoordList->GetAt(ID) == NULL){
		OutputDebugString("CPolygon::AddTail  ݂Ȃ_ID\n");
		return FALSE;
	}
	//do^Ȃ
	for(int i = 0;i < count;i++){
		if(ID == m_IDlist.GetAt(i)){
			OutputDebugString("CPolygon::AddTail  IDd\n");
			return FALSE;
		}
	}
	++(pCoordList->GetAt(ID)->count);
	m_IDlist.Add(ID);
	m_bArraySet = FALSE;
	m_bArraySizeChanged = TRUE;
	count++;
	return TRUE;
}
BOOL CPolygon::NoCheckAddTail(int ID){
	if((pCoordList == NULL) || (pCoordList->bAlive == FALSE)){
		return FALSE;
	}
	++(pCoordList->GetAt(ID)->count);
	m_IDlist.Add(ID);
	m_bArraySet = FALSE;
	m_bArraySizeChanged = TRUE;
	count++;
	return TRUE;
}
BOOL CPolygon::RemoveTail(){
	if((pCoordList == NULL) || (pCoordList->bAlive == FALSE))return FALSE;
	if(count < 1) return FALSE;
	//
	--(pCoordList->GetAt(m_IDlist.GetAt(count - 1))->count);
	m_bArraySet = FALSE;
	m_bArraySizeChanged = TRUE;
	//
	count--;
	m_IDlist.RemoveAt(count);
	return TRUE;
}

POINT* CPolygon::GetPointArray(){
	if((pCoordList == NULL) || (pCoordList->bAlive == FALSE))return FALSE;
	CCoord* pPos;
	if(!m_bArraySet){
		if(m_bArraySizeChanged){
			if(m_PointArray != NULL) delete [] m_PointArray;
			m_PointArray = new POINT[count];
			m_bArraySet = TRUE;
		}
		for(int i = 0;i<count;i++){
			if((pPos = pCoordList->GetAt(m_IDlist.GetAt(i))) == NULL) return NULL;
			(m_PointArray + i)->x = (LONG)(pPos->x);
			(m_PointArray + i)->y = (LONG)(pPos->y);
		}
		SetCentroid();
	}
	m_bArraySizeChanged = FALSE;
	return m_PointArray;
}


POSITION CCoordList::GetHeadPosition(){return m_Coordlist.GetHeadPosition();}
POSITION CCoordList::GetTailPosition(){return m_Coordlist.GetTailPosition();}
CCoord* CCoordList::GetNext(POSITION& pos){return (CCoord*)m_Coordlist.GetNext(pos);}
CCoord* CCoordList::GetPrev(POSITION& pos){return (CCoord*)m_Coordlist.GetPrev(pos);}
CCoord* CCoordList::GetAt(POSITION& pos){return (CCoord*)m_Coordlist.GetAt(pos);}
CCoord* CCoordList::GetAt(int ID){
	CCoord* pPos;
	POSITION pos = m_Coordlist.GetHeadPosition();
	while(pos != NULL ){
		pPos = (CCoord*)m_Coordlist.GetNext(pos);
		if(pPos->ID == ID) return pPos;
	}
	return NULL;
}

BOOL CCoordList::Add(CCoord Pos){
	CCoord* pPos;
	if(Pos.ID < 0){
		OutputDebugString("CCoordList::Add  _ID}CiX\n");
		cout << "error:_hc͂Oȏ\n";
		return FALSE;
	}
	POSITION pos = GetHeadPosition();
	while( pos != NULL ){
		pPos = GetNext(pos);
		if(*pPos == Pos){	//WID͔rĂȂ
			OutputDebugString("CCoordList::Add Wd\n");
			return FALSE;
		}
	}
	//
	pPos = new CCoord;
	*pPos = Pos;
	m_Coordlist.AddTail(pPos);
	count++;
	return TRUE;
}
BOOL CCoordList::NoCheckAdd(CCoord Pos){
	CCoord* pPos;
	pPos = new CCoord;
	*pPos = Pos;
	m_Coordlist.AddTail(pPos);
	count++;
	return TRUE;
}
CCoordList::~CCoordList(){
	POSITION pos = m_Coordlist.GetHeadPosition();
	while( pos != NULL ){
		delete (CCoord*)m_Coordlist.GetNext(pos);
	}
	m_Coordlist.RemoveAll();
	bAlive = FALSE;
}
int CCoordList::ValidNewID(){
	CCoord* pPos;
	//d͋Ȃ
	POSITION pos;
	BOOL bFound;
	for (int i = 1;i < 1000000;i++){
		bFound = FALSE;
		pos = GetHeadPosition();
		while( pos != NULL ){
			pPos = GetNext(pos);
			if(pPos->ID == i) bFound = TRUE;
		}
		if(!bFound)return i;
	}
	return -1;
}
BOOL CCoordList::GetDimension(CCoord* pTopRight,CCoord* pBottomLeft){
	double t = DBL_MIN;
	double r = DBL_MIN;
	double b = DBL_MAX;
	double l = DBL_MAX;
	CCoord* pPos;
	POSITION pos;
	pos = GetHeadPosition();
	while( pos != NULL ){
		pPos = GetNext(pos);
		t = max(t,pPos->y);	r = max(r,pPos->x);
		b = min(b,pPos->y); l = min(l,pPos->x);
	}
	pTopRight->y = t;pTopRight->x = r;
	pBottomLeft->y = b;pBottomLeft->x = l;
	return TRUE;
}
BOOL CCoordList::FitToSize(CCoord size){
	//ɈړEgEk܂
	CCoord TopRight,BottomLeft;
	GetDimension(&TopRight,&BottomLeft);
	double m;//{
	double width = TopRight.x-BottomLeft.x;
	double height = TopRight.y-BottomLeft.y;
	if(size.x / size.y > width / height){	//sizeAcɍ킹
		m = size.y / height;
		BottomLeft.x = BottomLeft.x * -1 + (size.x * height - size.y * width) / size.y / 2;
		BottomLeft.y = BottomLeft.y * -1;
	}else{
		m = size.x / width;
		BottomLeft.x = BottomLeft.x * -1;
		BottomLeft.y = BottomLeft.y * -1 + (size.y * width - size.x * height) / size.x / 2;
	}
	Shift(BottomLeft);
	Expand(m);
	return TRUE;
}

BOOL CCoordList::Remove(int i){
	POSITION posA,posB;
	CCoord* pPos;
	for(posA = GetHeadPosition(); ( posB = posA ) != NULL;){
		pPos = GetNext(posA);
		if(pPos->ID == i){
			if(i == -1) cout << "error:肦Ȃ\n";//-1Ȃ
			m_Coordlist.RemoveAt(posB);
			delete pPos;
			count--;
			return TRUE;
		}
	}
	return FALSE;
}
BOOL CPolyList::NoIntersect(){
	return Intersect(pCurrentPoly) == -1;
}
CCoord CPolyList::WhereIntersect(){
	CCoord res;
	if(pCoordList == NULL){
		res.x = -1;
		return res;
	}
	CPolygon* pPos;
	POSITION pos = m_Polylist.GetHeadPosition();
	while( pos != NULL ){
		pPos = GetNext(pos);
		res.x = Intersect(pPos);
		if(res.x > -1){
			res.y = pPos->PolyID;
			return res;
		}
	}
	return res;
}
int CPolyList::WhereSelfTwined(){
	if(pCoordList == NULL) return FALSE;
	CPolygon* pPos;
	POSITION pos = m_Polylist.GetHeadPosition();
	while( pos != NULL ){
		pPos = GetNext(pos);
		if(!pPos->NoSelfTwined()){
			return pPos->PolyID;
		}
	}
	return -1;
}

int CPolyList::Intersect(CPolygon* p){
	if(pCoordList == NULL) return -1;
	if(p == NULL) return -1;
	if(p->count < 2) return -1;
	CPolygon* pPoly;
	CCoord POS;
	POSITION pos;
	int i,j;
	int current,next;
	int pitch = 1;
	//̃|S̒_̒ɂ
	for(i = 0;i < p->count;i++){
		current = i;
		next = (i == p->count - 1) ? 0 : i + 1;
		for(j = 0 ;j < pitch ;j++){
			POS.x=(pCoordList->GetAt(p->m_IDlist.GetAt(current))->x * j + pCoordList->GetAt(p->m_IDlist.GetAt(next))->x * (pitch-j)) / pitch;
			POS.y=(pCoordList->GetAt(p->m_IDlist.GetAt(current))->y * j + pCoordList->GetAt(p->m_IDlist.GetAt(next))->y * (pitch-j)) / pitch;
			POS.ID = p->m_IDlist.GetAt(current);		//mFp
			pos = GetHeadPosition();
			while( pos != NULL ){
				pPoly = GetNext(pos);
				if(pPoly != p){
					if(pPoly->InPolygon(POS) == 1)
						return pPoly->PolyID;
				}
			}
		}
	}
	return -1;
}
CPolygon* CPolyList::NearestPolygon(CCoord Pos){
	double d = DBL_MAX;
	CPolygon* pPoly;
	//ŋߓ_܂ł̋
	POSITION pos = GetHeadPosition();
	while( pos != NULL ){
		pPoly = GetNext(pos);
		d = min(d,pPoly->CentroidDistance(Pos));
	}
	pos = GetHeadPosition();
	while( pos != NULL ){
		pPoly = GetNext(pos);
		//ȂŏԂ
		if(d == pPoly->CentroidDistance(Pos)) return pPoly;
	}
	return NULL;	//Ȃ
}


double CPolygon::Distance(CCoord pos){
	if((pCoordList == NULL) || (pCoordList->bAlive == FALSE))return FALSE;
	double d = DBL_MAX;
	//ŋߓ_܂ł̋
	double dx,dy;
	for(int i = 0;i<count;i++){
		dx = pos.x - pCoordList->GetAt(m_IDlist.GetAt(i))->x;
		dy = pos.y - pCoordList->GetAt(m_IDlist.GetAt(i))->y;
		d = min(d,sqrt(dx*dx + dy*dy));
	}
	return d;
}
double CPolygon::CentroidDistance(CCoord pos){
	if((pCoordList == NULL) || (pCoordList->bAlive == FALSE))return FALSE;
	//dS܂ł̋
	//SetCentroid();
	float dx = m_Centroid.x - pos.x;
	float dy = m_Centroid.y - pos.y;
	return (double)sqrt(dx*dx + dy*dy);
}
BOOL CCoordList::Expand(double d){
	if(d < 0.00001){
		OutputDebugString("cooord data will be lost\n");
		return FALSE;
	}
	CCoord* pPos;
	POSITION pos = GetHeadPosition();
	while( pos != NULL ){
		pPos = GetNext(pos);
		pPos->x = pPos->x * d;
		pPos->y = pPos->y * d;
	}
	return TRUE;
}
BOOL CCoordList::Shift(CCoord p){
	CCoord* pPos;
	POSITION pos = GetHeadPosition();
	while( pos != NULL ){
		pPos = GetNext(pos);
		pPos->x = pPos->x + p.x;
		pPos->y = pPos->y + p.y;
	}
	return TRUE;
}

int CCoordList::NearestPointID(CCoord Pos){
	double d = DBL_MAX;
	CCoord* pPos;
	//ŋߓ_܂ł̋
	POSITION pos = GetHeadPosition();
	while( pos != NULL ){
		pPos = GetNext(pos);
		d = min(d,pPos->Distance(Pos));
	}
	pos = GetHeadPosition();
	while( pos != NULL ){
		pPos = GetNext(pos);
		//ȂŏԂ
		if(d == pPos->Distance(Pos)) return pPos->ID;
	}
	return -1;	//Ȃ
}
int CCoordList::UnusedNearestPointID(CCoord Pos){
	double d = DBL_MAX;
	CCoord* pPos;
	//ŋߓ_܂ł̋
	POSITION pos = GetHeadPosition();
	while( pos != NULL ){
		pPos = GetNext(pos);
		if(pPos->count == 0) d = min(d,pPos->Distance(Pos));
	}
	pos = GetHeadPosition();
	while( pos != NULL ){
		pPos = GetNext(pos);
		//ȂŏԂ
		if((pPos->count == 0) && (d == pPos->Distance(Pos)))
			return pPos->ID;
	}
	return -1;	//Ȃ
}
BOOL CCoordList::DeleteUnused(){
	POSITION posA,posB;
	CCoord* pPos;
	for(posA = GetHeadPosition(); ( posB = posA ) != NULL;){
		pPos = GetNext(posA);
		if(pPos->count < 1){
			m_Coordlist.RemoveAt(posB);
			delete pPos;
			count--;
		}
	}
	return TRUE;
}
BOOL CCoordList::WriteToFile(const char* strFile){
	FILE* pFile;
	CCoord* pPos;
	pFile = fopen(strFile,"w");
	fprintf(pFile,"PolygonID\tX\tY\n");//^Cgs
	POSITION pos = m_Coordlist.GetHeadPosition();
	while( pos != NULL ){
		pPos = GetNext(pos);
		fprintf(pFile,"%d\t%f\t%f\n",pPos->ID,pPos->x,pPos->y);
	}
	fclose(pFile);
	return TRUE;
}
BOOL CCoordList::ReadFromFile(const char* strFile){
	FILE* pFile;
	CCoord Pos;
	char Buff[LINE_BUFFER];
	if((pFile = fopen(strFile,"r")) == NULL){
		cout << "error:t@CJȂ\n";
		return FALSE;
	}
	fgets(Buff,LINE_BUFFER,pFile);//PŝĂ
	while(!feof(pFile) && !ferror(pFile)){
		fscanf(pFile,"%d\t%lf\t%lf\n",&Pos.ID,&Pos.x,&Pos.y);
		if(!Add(Pos)){
			OutputDebugString("ǂ\n");
			return FALSE;
		}
	}
	return TRUE;
}

BOOL CCoordList::NoCheckReadFromFile(const char* strFile){
	//قȂhcœW
	//hc̏dȂ
	FILE* pFile;
	CCoord Pos;
	char Buff[LINE_BUFFER];
	if((pFile = fopen(strFile,"r")) == NULL){
		cout << "error:t@CJȂ\n";
		return FALSE;
	}
	fgets(Buff,LINE_BUFFER,pFile);//PŝĂ
	while(!feof(pFile) && !ferror(pFile)){
		fscanf(pFile,"%d\t%lf\t%lf\n",&Pos.ID,&Pos.x,&Pos.y);
		if(!NoCheckAdd(Pos)){
			OutputDebugString("ǂ\n");
			return FALSE;
		}
	}
	return TRUE;
}

BOOL CCoordList::IDIgnoreReadFromFile(const char* strFile){
	//ID𖳎ALȂhcVɊ蓖Ăēǂݍ
	FILE* pFile;
	CCoord Pos;
	char Buff[LINE_BUFFER];
	if((pFile = fopen(strFile,"r")) == NULL){
		cout << "error:t@CJȂ\n";
		return FALSE;
	}
	fgets(Buff,LINE_BUFFER,pFile);//PŝĂ
	while(!feof(pFile) && !ferror(pFile)){
		fscanf(pFile,"%d\t%lf\t%lf\n",&Pos.ID,&Pos.x,&Pos.y);
		Pos.ID = ValidNewID();
		Add(Pos); //W̑}͎s邾
	}
	return TRUE;
}

BOOL CPolyList::WriteToFile(const char* strFile){
	if(pCoordList == NULL) return FALSE;
	FILE* pFile;
	CPolygon* pPos;
	int i;
	pFile = fopen(strFile,"w");
	fprintf(pFile,"PolygonID\tOrder\tVertexID\n");//^Cgs
	POSITION pos = m_Polylist.GetHeadPosition();
	while( pos != NULL ){
		pPos = GetNext(pos);
		for(i=0;i<pPos->count;i++)
			if(pPos->count > 2)			//|SQȉ̕ۑ͔F߂Ȃ
				fprintf(pFile,"%d\t%d\t%d\n",pPos->PolyID,i,pPos->m_IDlist.GetAt(i));
	}
	fclose(pFile);
	return TRUE;
}

BOOL CPolyList::DataWriteToFile(const char* strFile){
	if(pCoordList == NULL) return FALSE;
	FILE* pFile;
	CPolygon* pPos;
	pFile = fopen(strFile,"w");
	fprintf(pFile,"PolygonID\tArea\tname\n");	//^Cgs
	POSITION pos = m_Polylist.GetHeadPosition();
	while( pos != NULL ){
		pPos = GetNext(pos);
		fprintf(pFile,"%d\t%10f\t%s\n",pPos->PolyID,abs(pPos->GetArea()),pPos->name);
	}
	fclose(pFile);
	return TRUE;
}
CCoord CPolyList::ReadFromFile(const char* strFile){
	// res.x = -2		t@CI[vÕG[
	// res.x = -1		t@CJȂ
	// res.x = 1		res.ỹ|SIDd
	// res.x = 2		res.y̍WID͂Ȃ
	// res.x = 3		res.y̍WIDŒǉɎs
	// res.x = 0		
	int Line = 1;
	CCoord res;
	res.x = -2;
	if(pCoordList == NULL){
		cout << "error:ǂޑOɍWNXƐڑKv\n";
		return res;
	}
	//|SID̓[ԖڂAifAԍj
	FILE* pFile;
	CPolygon Pos;
	char Buff[LINE_BUFFER];
	int PolyID,c,ID;
	if((pFile = fopen(strFile,"r")) == NULL){
		OutputDebugString("CPolyList::ReadFromFile t@CJȂ\n");
		cout << "error:t@CJȂ\n";
		res.x = -1;
		return res;
	}
	fgets(Buff,LINE_BUFFER,pFile);//PŝĂ
	while(!feof(pFile) && !ferror(pFile)){
		fscanf(pFile,"%d\t%d\t%d\n",&PolyID,&c,&ID);
		Line++;
		if(c == 0){
			if(!AddNewPolygon(PolyID)){
				OutputDebugString("PolyIDd\n");
				res.x = 1;res.y = Line;
				return res;
			}
		}
		if(pCoordList->GetAt(ID) == NULL){
			OutputDebugString("CPolygList::ReadFromFile@Wt@CɂȂIDgp\n");
			cout << "fatal error:Wt@CɂȂIDgp\n";
			res.x = 2;res.y = Line;
			return res;
		}
		if(!AddPosToCurrentPoly(ID)){
			res.x = 3;res.y = Line;
			return res;
		}
	}
	res.x = 0;
	return res;
}

CCoord CPolyList::NoCheckReadFromFile(const char* strFile){
	// res.x = -2		t@CI[vÕG[
	// res.x = -1		t@CJȂ
	// res.x = 1		res.ỹ|SIDd
	// res.x = 0		
	int Line = 1;
	CCoord res;
	res.x = -2;
	if(pCoordList == NULL){
		cout << "error:ǂޑOɍWNXƐڑKv\n";
		return res;
	}
	//|SID̓[ԖڂAifAԍj
	FILE* pFile;
	CPolygon Pos;
	char Buff[LINE_BUFFER];
	int PolyID,c,ID;
	if((pFile = fopen(strFile,"r")) == NULL){
		OutputDebugString("CPolyList::ReadFromFile t@CJȂ\n");
		res.x = -1;
		return res;
	}
	CString str;
	fgets(Buff,LINE_BUFFER,pFile);//PŝĂ
	while(!feof(pFile) && !ferror(pFile)){
		fscanf(pFile,"%d\t%d\t%d\n",&PolyID,&c,&ID);
		Line++;
		if(c == 0){
			NoCheckAddNewPolygon(PolyID);
			str.Format("Line = %d\n",Line);
			OutputDebugString(str);
		}
		NoCheckAddPosToCurrentPoly(ID);
	}
	res.x = 0;
	return res;
}

CCoord CPolyList::ReadDataFile(const char* strFile){
	// ׂẴ|SɃf[^AOȂĂ\Ȃ
	CCoord c;
	c.x = 100;c.y = 0;//ŝ߂̃ftHgl
	if(count < 1){
		cout << "error:Ƀ|SǂޕKv܂\n";
		return c;
	}
	//|SID{^u{f[^{^u{́ifAԍj
	FILE* pFile;
	CPolygon* pPos;
	char Buff[LINE_BUFFER];
	int PolyID,i;
	POSITION pos;
	double data;
	if((pFile = fopen(strFile,"r")) == NULL){
		cout << "error:t@CJȂ\n";
		return c;
	}
	c.x = DBL_MIN;c.y = DBL_MAX;
	fgets(Buff,LINE_BUFFER,pFile);//PŝĂ
	while(!feof(pFile) && !ferror(pFile)){
		memset(Buff,NULL,LINE_BUFFER);
		fgets(Buff,100,pFile);
		PolyID = atoi(Buff);
		for(i = 0;i < LINE_BUFFER - 1;i++) if(*(Buff + i) == '\t') break;
		data = atof(Buff + i + 1);
		for(i++;i < LINE_BUFFER - 1;i++) if(*(Buff + i) == '\t') break;//̐擪T
		pos = m_Polylist.GetHeadPosition();
		while( pos != NULL ){
			pPos = GetNext(pos);
			if(pPos->PolyID == PolyID){
				pPos->data = data;
				strcpy_s(pPos->name,(const char*)(Buff + i + 1));
				c.x = max(c.x,data);c.y = min(c.y,data);
			}
		}
	}
	fclose(pFile);
	m_bData = TRUE;
	return c;
}

BOOL CPolyList::AddPosToCurrentPoly(CCoord pos){
	if(pCoordList == NULL) return FALSE;
	int ID = pCoordList->NearestPointID(pos);
	return pCurrentPoly->AddTail(ID);
}
BOOL CPolyList::AddPosToCurrentPoly(int ID){
	if(pCoordList == NULL) return FALSE;
	return pCurrentPoly->AddTail(ID);
}
BOOL CPolyList::NoCheckAddPosToCurrentPoly(int ID){
	if(pCoordList == NULL) return FALSE;
	return pCurrentPoly->NoCheckAddTail(ID);
}
BOOL CPolyList::RemovePosFromCurrentPoly(){
	if(pCoordList == NULL) return FALSE;
	return pCurrentPoly->RemoveTail();
}
//--------------|S̕tʐ--------------
//vȂ琳̖ʐ
double CPolygon::GetArea(){
	if(pCoordList == NULL) return NULL;
	if(count < 2) return 0.0;
	int prev,current,next;
	double area = 0;
	for(int i = 0;i < count;i++){
		prev = (i == 0) ? count - 1 : i - 1;
		current = i;
		next = (i == count - 1) ? 0 : i + 1;
		area += (pCoordList->GetAt(m_IDlist.GetAt(prev))->x - pCoordList->GetAt(m_IDlist.GetAt(next))->x)
			* pCoordList->GetAt(m_IDlist.GetAt(current))->y;
	}
	return area / 2;
}
BOOL CPolyList::ArrayUnset(void){
	//z𖳌ɂ
	//Az͕̐ωȂ
	if(pCoordList == NULL) return FALSE;
	CPolygon* pPos;
	POSITION pos = m_Polylist.GetHeadPosition();
	while( pos != NULL ){
		pPos = GetNext(pos);
		pPos->m_bArraySet = FALSE;
	}
	return TRUE;
}

/*
CCoord CPolygon::GetCentroid(){
	//|S̉]ɍEiꎞp~j
	CCoord res;
	GetPointArray();
	if(count < 3){
		return res;
	}
	int i;
	float dx = 0;
	float dy = 0;
	float area_sum = 0;
	float area;
	for(i = 0;i < count - 2;i++){
		area = (float)abs(((m_PointArray[i+1].x - m_PointArray[0].x)*(m_PointArray[i].y - m_PointArray[0].y) - (m_PointArray[i+1].y - m_PointArray[0].y)*(m_PointArray[i].x - m_PointArray[0].x))) / 2;
		if(area == 0) area = 0.1f;
		area_sum += area;
		dx += (m_PointArray[0].x + m_PointArray[i].x + m_PointArray[i+1].x) * area / 3; 
		dy += (m_PointArray[0].y + m_PointArray[i].y + m_PointArray[i+1].y) * area / 3;
	}
	res.x = dx/area_sum;
	res.y = dy/area_sum;
	return res;
}
*/
BOOL CPolygon::SetCentroid(){
	//P
	if(count < 3) return FALSE;
	float dx = 0;
	float dy = 0;
	for(int i = 0;i < count;i++){
		dx += (float)(pCoordList->GetAt(m_IDlist.GetAt(i))->x); 
		dy += (float)(pCoordList->GetAt(m_IDlist.GetAt(i))->y);
	}
	m_Centroid.x = (double)(dx/(float)count);
	m_Centroid.y = (double)(dy/(float)count);
	return TRUE;
}

POSITION CEdgeList::GetHeadPosition(){return m_Edgelist.GetHeadPosition();}
POSITION CEdgeList::GetTailPosition(){return m_Edgelist.GetTailPosition();}
CEdge* CEdgeList::GetNext(POSITION& pos){return (CEdge*)m_Edgelist.GetNext(pos);}
CEdge* CEdgeList::GetPrev(POSITION& pos){return (CEdge*)m_Edgelist.GetPrev(pos);}
CEdge* CEdgeList::GetAt(POSITION& pos){return (CEdge*)m_Edgelist.GetAt(pos);}
CEdgeList::~CEdgeList(){
	POSITION pos = m_Edgelist.GetHeadPosition();
	while( pos != NULL ){
		delete (CEdge*)m_Edgelist.GetNext(pos);
	}
	m_Edgelist.RemoveAll();
};
CEdge* CEdgeList::GetEdge(int Start,int End){
	POSITION pos = m_Edgelist.GetHeadPosition();
	int Bigger = Start > End ? Start : End;
	int Smaller = Start < End ? Start : End;
	CEdge* tmpEdge;
	while( pos != NULL ){
		tmpEdge = GetNext(pos);
		if((tmpEdge->P[0] == Smaller) && (tmpEdge->P[1] == Bigger)){
			return tmpEdge;
		}
	}
	//Ȃ
	tmpEdge = new CEdge;
	tmpEdge->P[0] = Smaller;
	tmpEdge->P[1] = Bigger;
	m_Edgelist.AddTail(tmpEdge);
	return tmpEdge;
};
CEdgeList::CEdgeList(CPolyList &Poly){
	POSITION pos = Poly.GetHeadPosition();
	CPolygon* pPoly;
	CEdge* tmpEdge;
	int i,j;
	while(pos != NULL){
		pPoly = Poly.GetNext(pos);
		for(i = 0;i < pPoly->count;i++){
			j = (i < pPoly->count - 1) ? i + 1 : 0;
			tmpEdge = GetEdge(pPoly->m_IDlist[i],pPoly->m_IDlist[j]);
			if(tmpEdge->nPolygon[0] != 0){	//łɂGbW
				if(tmpEdge->nPolygon[0] > pPoly->PolyID){
					tmpEdge->nPolygon[1] = tmpEdge->nPolygon[0];
					tmpEdge->nPolygon[0] = pPoly->PolyID;
				}
				else{
					tmpEdge->nPolygon[1] = pPoly->PolyID;
				}
			}
			else{
				tmpEdge->nPolygon[0] = pPoly->PolyID;
			}
		}
	}
}
