#pragma once

//#include "math.h"
#include <iostream>
#include <fstream>
#include <math.h>
#include <limits>
#include <float.h>

#define LINE_BUFFER	100

using namespace std;

class CCoord{
public:
	double x,y;
	int ID;		//}CiX͋Ȃ
	int count;	//QƉ
	BOOL operator==(CCoord pos){if(x == pos.x && y == pos.y) return TRUE; else return FALSE;}
	CCoord& operator=(const CCoord& pos){
		x = pos.x;y = pos.y;count = 0;ID = pos.ID;
		return *this;}
	CCoord() {x = y = ID = -1;count = 0;}
	double Distance(CCoord pos){
		double dx = pos.x - x;
		double dy = pos.y - y;
		return sqrt(dx*dx + dy*dy);
	}
	void Set(double tx,double ty,int tID = 0){x=tx;y=ty;ID=tID;count = 0;}
	~CCoord() {;}
};

class CCoordList{
	CPtrList m_Coordlist;
public:
	BOOL GetDimension(CCoord* pTopRight,CCoord* pBottomLeft);
	BOOL FitToSize(CCoord size);
	BOOL Expand(double d);
	BOOL Shift(CCoord pos);
	BOOL Add(CCoord pos);
	BOOL NoCheckAdd(CCoord pos);
	BOOL Remove(int ID);
	int NearestPointID(CCoord pos);
	int UnusedNearestPointID(CCoord pos);
	int ValidNewID();
	BOOL DeleteUnused();
	BOOL WriteToFile(const char* strFile);
	BOOL ReadFromFile(const char* strFile);
	BOOL NoCheckReadFromFile(const char* strFile);
	BOOL IDIgnoreReadFromFile(const char* strFile);
	CCoord* GetAt(int ID);
	int count;
	BOOL bAlive;
	BOOL bFloat;
	CCoordList(){count = 0;bAlive = TRUE;bFloat = FALSE;}
	~CCoordList();
	CCoord* GetAt(POSITION& pos);
	POSITION GetHeadPosition();
	POSITION GetTailPosition();
	CCoord* GetNext(POSITION& pos);
	CCoord* GetPrev(POSITION& pos);
};

class CPolygon{
	CCoordList* pCoordList;
public:
	CCoord m_Centroid;
	BOOL SetCentroid();
	BOOL m_bArraySet;
	BOOL m_bArraySizeChanged;
	CUIntArray m_IDlist;
	POINT* m_PointArray;
	int count;
	char name[LINE_BUFFER];
	COLORREF color;
	double data;
	int PolyID;
	void Bind(CCoordList* p){pCoordList = p;}
	double Distance(CCoord pos);
	double GetArea();
	double CentroidDistance(CCoord pos);
	BOOL AddTail(int ID);
	BOOL NoCheckAddTail(int ID);
	BOOL RemoveTail();
	BOOL NoSelfTwined();
	POINT* GetPointArray();
	int InPolygon(CCoord Pos);
	int IsCrossing(CCoord Pos, CCoord* p1, CCoord* p2);
	CPolygon(){m_PointArray = NULL;name[0]=NULL;PolyID = -1;count = 0;m_bArraySet = FALSE;m_bArraySizeChanged = TRUE;pCoordList = NULL;color = RGB(5,5,5);}
	~CPolygon();
};
class CPolyList{
	CPtrList m_Polylist;
	CCoordList* pCoordList;
public:
	BOOL m_bData;
	void Bind(CCoordList* p){pCoordList = p;}
	BOOL AddNewPolygon(int PolyID);
	BOOL RenameCurrentPolygon(int PolyID);
	BOOL RemovePolygonGroup(int From,int To);
	BOOL NoCheckAddNewPolygon(int PolyID);
	BOOL RemoveCurrentPolygon();
	BOOL ChangeCurrentPolygon(CCoord pos);
	BOOL WriteToFile(const char* strFile);
	BOOL DataWriteToFile(const char* strFile);
	CCoord ReadFromFile(const char* strFile);		//G[Ԃ
	CCoord NoCheckReadFromFile(const char* strFile);		//G[Ԃ
	CCoord ReadDataFile(const char* strFile);		//őlEŏlԂ
	BOOL AddPosToCurrentPoly(CCoord pos);
	BOOL AddPosToCurrentPoly(int ID);
	BOOL NoCheckAddPosToCurrentPoly(int ID);
	BOOL RemovePosFromCurrentPoly();
	CPolygon* NearestPolygon(CCoord pos);
	int Intersect(CPolygon* pPoly);
	CCoord WhereIntersect();
	int WhereSelfTwined();
	BOOL NoIntersect();
	int GetCurrentPolySize(){return (pCurrentPoly == NULL) ? 0 : pCurrentPoly->count;}
	int GetCurrentPolyID(){return (pCurrentPoly == NULL) ? -1 : pCurrentPoly->PolyID;}
	CCoord GetCurrentPolyPosition(){
		CCoord res;
		if(pCurrentPoly != NULL) pCurrentPoly->SetCentroid();
		return (pCurrentPoly == NULL) ? res : pCurrentPoly->m_Centroid;
	}
	int count;
	CPolygon* pCurrentPoly;
	CPolyList(){count = 0;pCurrentPoly = NULL;pCoordList = NULL;m_bData = FALSE;}
	~CPolyList();
	CPolygon* GetAt(POSITION& pos);
	POSITION GetHeadPosition();
	POSITION GetTailPosition();
	CPolygon* GetNext(POSITION& pos);
	CPolygon* GetPrev(POSITION& pos);
	BOOL ArrayUnset(void);
};
class CEdge{
public:
	int nPolygon[2];	//|S
	CEdge(){nPolygon[0] = nPolygon[1] = 0;};
	int P[2];	//[̍W_ID(KP[0]ɓ)
	bool operator==(const CEdge &a)const{return (P[0] == a.P[0] && P[1] == a.P[1]);}	//rZq
};
class CEdgeList{
public:
	CPtrList m_Edgelist;
	CEdgeList();
	CEdgeList(CPolyList &Poly);
	~CEdgeList();
	CEdge* GetAt(POSITION& pos);
	POSITION GetHeadPosition();
	POSITION GetTailPosition();
	CEdge* GetNext(POSITION& pos);
	CEdge* GetPrev(POSITION& pos);
	CEdge* GetEdge(int Start,int End);
};

